# YaoArrayRegister

Simulated Full Amplitude Quantum Register.

## Introduction

YaoArrayRegister.jl is a component package in the [Yao.jl](https://github.com/QuantumBFS/Yao.jl) ecosystem. It provides the most basic functionality for quantum
computation simulation in Julia and a quantum register type `ArrayReg`. You will be
able to simulate a quantum circuit alone with this package in principle.

## Installation

In Julia **v1.0+**, please type `]` in the REPL to use the package mode, then type this command:

```julia
pkg> add YaoArrayRegister
```

## Usage

This package implements `AbstractRegister` interfaces on the array storage, you can use it like other kind of registers intuitively.

## License

Apache License 2.0

# NOTE:
# in principal we only allow one to input a tuple of address to instruct
# but most of the instruct function in this file defines a forward method
# for single qubit version with an int as input.
#
#
# In order to make multi threading work, the state vector MUST be named as state

function YaoAPI.instruct!(r::DensityMatrix{D}, operator, locs::Tuple) where {D}
    length(locs) == 0 && return r
    # TODO: check cuda implementation
    n = nqudits(r)
    instruct!(Val(D), vec(r.state), operator, locs)
    instruct!(Val(D), vec(r.state), _conj(operator), locs .+ n)
    return r
end
function YaoAPI.instruct!(r::DensityMatrix{D}, operator, locs::Tuple, control_locs, control_bits) where {D}
    length(locs) == 0 && return r
    n = nqudits(r)
    instruct!(Val(D), vec(r.state), _match_type(r.state, operator), locs, control_locs, control_bits)
    instruct!(Val(D), vec(r.state), _match_type(r.state, _conj(operator)), locs .+ n, control_locs .+ n, control_bits)
    return r
end
function YaoAPI.instruct!(r::DensityMatrix{D}, operator, locs::Tuple, theta::Number) where {D}
    length(locs) == 0 && return r
    n = nqudits(r)
    instruct!(Val(D), vec(r.state), _match_type(r.state, operator), locs, theta)
    operator, theta = _conj(operator, theta)
    instruct!(Val(D), vec(r.state), _match_type(r.state, operator), locs .+ n, theta)
    return r
end
_conj(x::AbstractArray) = conj(x)
_conj(::Val{:X}) = Val(:X)
_conj(::Val{:Y}) = conj(Const.Y)
_conj(::Val{:Z}) = Val(:Z)
_conj(::Val{:S}) = Val(:Sdag)
_conj(::Val{:T}) = Val(:Tdag)
_conj(::Val{:H}) = Val(:H)
_conj(::Val{:Sdag}) = Val(:S)
_conj(::Val{:Tdag}) = Val(:T)
_conj(::Val{:SWAP}) = Val(:SWAP)

# parameterized
_conj(::Val{:Rx}, theta) = Val(:Rx), -conj(theta)
_conj(::Val{:Ry}, theta) = Val(:Ry), conj(theta)
_conj(::Val{:Rz}, theta) = Val(:Rz), -conj(theta)
_conj(::Val{:PSWAP}, theta) = Val(:PSWAP), -conj(theta)
_conj(::Val{:CPHASE}, theta) = Val(:CPHASE), -conj(theta)

function YaoAPI.instruct!(r::BatchedArrayReg{D}, operator, locs::Tuple, args...) where {D}
    length(locs) == 0 && return r
    instruct!(Val(D), r.state, _match_type(r.state, operator), locs, args...)
    return r
end
function YaoAPI.instruct!(r::ArrayReg{D}, operator, locs::Tuple, args...) where {D}
    length(locs) == 0 && return r
    instruct!(Val(D), vec(r.state), _match_type(r.state, operator), locs, args...)
    return r
end
_match_type(::AbstractVecOrMat{T1}, operator::Val) where {T1} = operator
_match_type(::AbstractVecOrMat{T1}, operator::AbstractMatrix{T1}) where {T1} = operator
function _match_type(::AbstractVecOrMat{T1}, operator::AbstractMatrix{T2}) where {T1,T2}
    @warn "Element Type Mismatch: register $(T1), operator $(T2). Converting operator to match, this may cause performance issue"
    return copyto!(similar(operator, T1), operator)
end

"""
    SPECIALIZATION_LIST::Vector{Symbol}

A list of symbol for specialized gates/operators.
"""
const SPECIALIZATION_LIST =
    Symbol[:X, :Y, :Z, :S, :T, :Sdag, :Tdag, :H, :SWAP, :PSWAP, :CPHASE]


const THREAD_THRESHOLD = 10

# generates the threading expression
macro threads(ex)
    esc(quote
        if (Threads.nthreads() == 1) || log2dim1(state) < $THREAD_THRESHOLD
            @inbounds $ex
        else
            @inbounds Threads.@threads $ex
        end
    end)
end

# the most generic matrix interface.
function YaoAPI.instruct!(::Val{2},
    state::AbstractVecOrMat{T},
    operator::AbstractMatrix{T},
    locs::NTuple{M,Int},
    control_locs::NTuple{C,Int},
    control_bits::NTuple{C,Int},
) where {T,M,C}
    # prepare instruct
    N = log2dim1(state)
    operator = sort_unitary(Val(2), operator, locs)  # make locs ordered

    # get itercontrol and locs_raw
    locked_bits = MVector(control_locs..., locs...)
    locked_vals = MVector(control_bits..., (0 for k = 1:M)...)
    locs_raw_it = (b + 1 for b in itercontrol(N, setdiff(1:N, locs), zeros(Int, N - M)))
    locs_raw = SVector(locs_raw_it...)
    ic = itercontrol(N, locked_bits, locked_vals)

    return _instruct!(state, autostatic(operator), locs_raw, ic)
end
function _instruct!(
    state::AbstractVecOrMat{T},
    U::AbstractMatrix{T},
    locs_raw::SVector,
    ic::IterControl,
) where {T}
    @threads for j = 1:length(ic)
        @inbounds i = ic[j]
        @inbounds unrows!(state, locs_raw .+ i, U)
    end
    return state
end

function _instruct!(
    state::AbstractVecOrMat{T},
    U::SDSparseMatrixCSC{T},
    locs_raw::SVector,
    ic::IterControl,
) where {T}
    work =
        ndims(state) == 1 ? similar(state, length(locs_raw)) :
        similar(state, length(locs_raw), size(state, 2))
    for j = 1:length(ic)
        @inbounds i = ic[j]
        @inbounds unrows!(state, locs_raw .+ i, U, work)
    end
    return state
end
function YaoAPI.instruct!(::Val{2},  # fallback to controlled case
    state::AbstractVecOrMat{T},
    operator::AbstractMatrix{T},
    locs::NTuple{M,Int}
) where {T,M}
    if M == 1
        return single_qubit_instruct!(state, operator, locs[1])
    end
    instruct!(Val(2), state, operator, locs, (), ())
end

# specialize: IMatrix
YaoAPI.instruct!(::Val{2}, state::AbstractVecOrMat, U::IMatrix, locs::NTuple{N,Int}) where N = state

# specialize: single qubit generic matrix
function single_qubit_instruct!(state::AbstractVecOrMat{T}, U1::AbstractMatrix{T}, loc::Int) where {T}
    a, c, b, d = U1
    instruct_kernel(state, loc, 1 << (loc - 1), 1 << loc, a, b, c, d)
    return state
end

@inline function instruct_kernel(state::AbstractVecOrMat, loc, step1, step2, a, b, c, d)
    @threads for j = 0:step2:size(state, 1)-step1
        @inbounds for i = j+1:j+step1
            u1rows!(state, i, i + step1, a, b, c, d)
        end
    end
    return state
end

# specialize: single qubit IMatrix
single_qubit_instruct!(state::AbstractVecOrMat, U::IMatrix, loc::Int) = state

# specialize: single qubit permutation matrix
function single_qubit_instruct!(state::AbstractVecOrMat{T}, U1::SDPermMatrix{T}, loc::Int) where {T}
    U1.perm[1] == 1 && return instruct!(Val(2),state, Diagonal(U1), (loc,))
    b, c = U1.vals
    step = 1 << (loc - 1)
    step_2 = 1 << loc

    @threads for j = 0:step_2:size(state, 1)-step
        @inbounds for i = j+1:j+step
            swaprows!(state, i, i + step, c, b)
        end
    end
    return state
end

# specialize: single qubit diagonal matrix
function single_qubit_instruct!(state::AbstractVecOrMat{T}, U1::SDDiagonal{T}, loc::Int) where {T}
    a, d = U1.diag
    step = 1 << (loc - 1)
    step_2 = 1 << loc
    @threads for j = 0:step_2:size(state, 1)-step
        @inbounds for i = j+1:j+step
            mulrow!(state, i, a)
            mulrow!(state, i + step, d)
        end
    end
    return state
end

# specialize: named gates
# paulis
function YaoAPI.instruct!(::Val{2},
    state::AbstractVecOrMat,
    ::Val{:X},
    locs::NTuple{N,Int},
) where {N}
    mask = bmask(locs)
    do_mask = bmask(first(locs))
    @threads for b in basis(state)
        @inbounds if anyone(b, do_mask)
            i = b + 1
            i_ = flip(b, mask) + 1
            swaprows!(state, i, i_)
        end
    end
    return state
end

function YaoAPI.instruct!(::Val{2},
    state::AbstractVecOrMat{T},
    ::Val{:H},
    locs::NTuple{N,Int},
) where {T, N}
    instruct!(Val(2), state, _hadamard_matrix(T), locs)
end
# this is an interface for future extension (e.g. in YaoSym)
_hadamard_matrix(::Type{T}) where T = matchtype(T, YaoArrayRegister.Const.H)

function YaoAPI.instruct!(::Val{2},
    state::AbstractVecOrMat{T},
    ::Val{:Y},
    locs::NTuple{N,Int},
) where {T,N}
    mask = bmask(Int, locs)
    do_mask = bmask(Int, first(locs))
    bit_parity = iseven(length(locs)) ? 1 : -1
    factor = T(-im)^length(locs)

    @threads for b in basis(state)
        if anyone(b, do_mask)
            i = b + 1
            i_ = flip(b, mask) + 1
            factor1 = isodd(count_ones(b & mask)) ? -factor : factor
            factor2 = factor1 * bit_parity
            swaprows!(state, i, i_, factor2, factor1)
        end
    end
    return state
end

function YaoAPI.instruct!(::Val{2},
    state::AbstractVecOrMat{T},
    ::Val{:Z},
    locs::NTuple{N,Int},
) where {T,N}
    mask = bmask(Int, locs)
    @threads for b in basis(state)
        if isodd(count_ones(b & mask))
            mulrow!(state, b + 1, -1)
        end
    end
    return state
end

for (G, FACTOR) in zip(
    [:S, :T, :Sdag, :Tdag],
    [:(im), :($(exp(im * π / 4))), :(-im), :($(exp(-im * π / 4)))],
)
    @eval function YaoAPI.instruct!(::Val{2},
        state::AbstractVecOrMat{T},
        ::Val{$(QuoteNode(G))},
        locs::NTuple{N,Int},
    ) where {T,N}
        mask = bmask(Int, locs)
        @threads for b in basis(state)
            mulrow!(state, b + 1, $FACTOR^count_ones(b & mask))
        end
        return state
    end
end

for (G, FACTOR) in zip(
    [:Z, :S, :T, :Sdag, :Tdag],
    [:(-1), :(im), :($(exp(im * π / 4))), :(-im), :($(exp(-im * π / 4)))],
)
    # no effect (to fix ambiguity)
    @eval YaoAPI.instruct!(::Val{2}, st::AbstractVecOrMat, ::Val{$(QuoteNode(G))}, ::Tuple{}) = st

    @eval function YaoAPI.instruct!(::Val{2},
        state::AbstractVecOrMat{T},
        ::Val{$(QuoteNode(G))},
        (loc,)::Tuple{Int},
    ) where {T}
        mask = bmask(loc)
        step = 1 << (loc - 1)
        step_2 = 1 << loc
        @threads for j = 0:step_2:size(state, 1)-step
            for i = j+step+1:j+step_2
                mulrow!(state, i, $FACTOR)
            end
        end
        state
    end
end

# General definition
function rot_mat(::Type{T}, gen::AbstractMatrix, theta::Real) where {T}
    I = IMatrix{T}(size(gen, 1))
    m = I * cos(theta / 2) - im * sin(theta / 2) * gen
    if eltype(m) != T
        m2 = similar(m, T)
        copyto!(m2, m)
        return m2
    else
        return m
    end
end
# Specialized
parametric_mat(::Type{T}, ::Val{:Rx}, theta::Number) where {T} =
    T[cos(theta / 2) -im*sin(theta / 2); -im*sin(theta / 2) cos(theta / 2)]
parametric_mat(::Type{T}, ::Val{:Ry}, theta::Number) where {T} =
    T[cos(theta / 2) -sin(theta / 2); sin(theta / 2) cos(theta / 2)]
parametric_mat(::Type{T}, ::Val{:Rz}, theta::Number) where {T} =
    Diagonal(T[exp(-im * theta / 2), exp(im * theta / 2)])
parametric_mat(::Type{T}, ::Val{:CPHASE}, theta::Number) where {T} =
    Diagonal(T[1, 1, 1, exp(im * theta)])
parametric_mat(::Type{T}, ::Val{:PSWAP}, theta::Number) where {T} = rot_mat(T, Const.SWAP, theta)

for G in [:Rx, :Ry, :Rz, :CPHASE]
    # forward single gates
    @eval function YaoAPI.instruct!(::Val{2},
        state::AbstractVecOrMat{T},
        g::Val{$(QuoteNode(G))},
        locs::NTuple{N3,Int},
        control_locs::NTuple{N1,Int},
        control_bits::NTuple{N2,Int},
        theta::Number,
    ) where {T,N1,N2,N3}
        m = parametric_mat(T, g, theta)
        instruct!(Val(2), state, m, locs, control_locs, control_bits)
        return state
    end
end # for

@inline function YaoAPI.instruct!(::Val{2},
    state::AbstractVecOrMat{T},
    ::Val{:Rx},
    (loc,)::Tuple{Int},
    theta::Number,
) where {T}
    b, a = sincos(theta / 2)
    instruct_kernel(state, loc, 1 << (loc - 1), 1 << loc, a, -im * b, -im * b, a)
    return state
end

function YaoAPI.instruct!(::Val{2},
    state::AbstractVecOrMat{T},
    ::Val{:Ry},
    (loc,)::Tuple{Int},
    theta::Number,
) where {T}
    b, a = sincos(theta / 2)
    instruct_kernel(state, loc, 1 << (loc - 1), 1 << loc, a, -b, b, a)
    return state
end

function YaoAPI.instruct!(::Val{2},
    state::AbstractVecOrMat{T},
    ::Val{:Rz},
    (loc,)::Tuple{Int},
    theta::Number,
) where {T}
    a = exp(-im * theta / 2)
    instruct_kernel(state, loc, 1 << (loc - 1), 1 << loc, a, zero(T), zero(T), a')
    return state
end

function YaoAPI.instruct!(::Val{2},
    state::AbstractVecOrMat{T},
    ::Val{:CPHASE},
    locs::NTuple{N,Int},
    theta::Number,
) where {T,N}
    m = parametric_mat(T, Val(:CPHASE), theta)
    instruct!(Val(2), state, m, locs)
    return state
end


# forward single gates
function YaoAPI.instruct!(::Val{2},
    state::AbstractVecOrMat{T},
    g::Val,
    locs::Union{Int,NTuple{N1,Int}},
    theta::Number,
) where {T,N1}
    instruct!(Val(2), state, g, locs, (), (), theta)
end

function YaoAPI.instruct!(::Val{2},
    state::AbstractVecOrMat{T},
    ::Val{:X},
    locs::NTuple{N1,Int},
    control_locs::NTuple{N2,Int},
    control_bits::NTuple{N3,Int},
) where {T,N1,N2,N3}

    ctrl = controller((control_locs..., locs[1]), (control_bits..., 0))
    mask2 = bmask(locs)
    @threads for b in basis(state)
        if ctrl(b)
            i = b + 1
            i_ = flip(b, mask2) + 1
            swaprows!(state, i, i_)
        end
    end
    return state
end

function YaoAPI.instruct!(::Val{2},
    state::AbstractVecOrMat{T},
    ::Val{:Y},
    locs::NTuple{N1,Int},
    control_locs::NTuple{N2,Int},
    control_bits::NTuple{N3,Int},
) where {T,N1,N2,N3}

    ctrl = controller((control_locs..., locs[1]), (control_bits..., 0))
    mask2 = bmask(locs)
    @threads for b in basis(state)
        if ctrl(b)
            i = b + 1
            i_ = flip(b, mask2) + 1
            swaprows!(state, i, i_, im, -im)
        end
    end
    return state
end

for (G, FACTOR) in zip(
    [:Z, :S, :T, :Sdag, :Tdag],
    [:(-1), :(im), :($(exp(im * π / 4))), :(-im), :($(exp(-im * π / 4)))],
)
    @eval function YaoAPI.instruct!(::Val{2},
        state::AbstractVecOrMat{T},
        ::Val{$(QuoteNode(G))},
        locs::NTuple{N1,Int},
        control_locs::NTuple{N2,Int},
        control_bits::NTuple{N3,Int},
    ) where {T,N1,N2,N3}

        ctrl = controller([control_locs..., locs[1]], [control_bits..., 1])
        @threads for b in basis(state)
            if ctrl(b)
                mulrow!(state, b + 1, $FACTOR)
            end
        end
        return state
    end
end

## single controlled paulis
for G in [:X, :Y, :Z, :S, :T, :Sdag, :Tdag]
    # forward single controlled
    @eval YaoAPI.instruct!(::Val{2},
        state::AbstractVecOrMat,
        g::Val{$(QuoteNode(G))},
        locs::NTuple{N,Int},
        control_locs::Tuple{Int},
        control_bits::Tuple{Int},
    ) where {N} = instruct!(Val(2), state, g, locs, control_locs..., control_bits...)

    # forward single location
    @eval YaoAPI.instruct!(::Val{2},
        state::AbstractVecOrMat,
        g::Val{$(QuoteNode(G))},
        locs::Tuple{Int},
        control_locs::Int,
        control_bits::Int,
    ) = instruct!(Val(2), state, g, locs..., control_locs, control_bits)

end

function YaoAPI.instruct!(::Val{2},
    state::AbstractVecOrMat{T},
    ::Val{:X},
    loc::Int,
    control_locs::Int,
    control_bits::Int,
) where {T}

    mask2 = bmask(loc)
    mask = bmask(control_locs, loc)
    step = 1 << (control_locs - 1)
    step_2 = 1 << control_locs
    start = control_bits == 1 ? step : 0
    @threads for j = start:step_2:size(state, 1)-step+start
        for b = j:j+step-1
            @inbounds if allone(b, mask2)
                i = b + 1
                i_ = flip(b, mask2) + 1
                swaprows!(state, i, i_)
            end
        end
    end
    return state
end

function YaoAPI.instruct!(::Val{2},
    state::AbstractVecOrMat{T},
    ::Val{:Y},
    loc::Int,
    control_locs::Int,
    control_bits::Int,
) where {T}

    mask2 = bmask(loc)
    mask = bmask(control_locs, loc)
    step = 1 << (control_locs - 1)
    step_2 = 1 << control_locs
    start = control_bits == 1 ? step : 0
    @threads for j = start:step_2:size(state, 1)-step+start
        for b = j:j+step-1
            @inbounds if allone(b, mask2)
                i = b + 1
                i_ = flip(b, mask2) + 1
                if allone(b, mask2)
                    factor = T(im)
                else
                    factor = T(-im)
                end
                swaprows!(state, i, i_, -factor, factor)
            end
        end
    end
    return state
end


for (G, FACTOR) in zip(
    [:Z, :S, :T, :Sdag, :Tdag],
    [:(-1), :(im), :($(exp(im * π / 4))), :(-im), :($(exp(-im * π / 4)))],
)
    @eval function YaoAPI.instruct!(::Val{2},
        state::AbstractVecOrMat{T},
        ::Val{$(QuoteNode(G))},
        loc::Int,
        control_locs::Int,
        control_bits::Int,
    ) where {T}

        mask2 = bmask(loc)
        step = 1 << (control_locs - 1)
        step_2 = 1 << control_locs
        start = control_bits == 1 ? step : 0
        @threads for j = start:step_2:size(state, 1)-step+start
            for i = j+1:j+step
                if allone(i - 1, mask2)
                    mulrow!(state, i, $FACTOR)
                end
            end
        end
        return state
    end
end

# 2-qubit gates
function YaoAPI.instruct!(::Val{2},
    state::AbstractVecOrMat{T},
    ::Val{:SWAP},
    locs::Tuple{Int,Int},
) where {T}

    mask1 = bmask(locs[1])
    mask2 = bmask(locs[2])
    mask12 = mask1 | mask2
    @threads for b in basis(state)
        if b & mask1 == 0 && b & mask2 == mask2
            i = b + 1
            i_ = b ⊻ mask12 + 1
            swaprows!(state, i, i_)
        end
    end
    return state
end

function YaoAPI.instruct!(::Val{2},
    state::AbstractVecOrMat{T},
    ::Val{:PSWAP},
    locs::Tuple{Int,Int},
    theta::Number,
) where {T}
    mask1 = bmask(locs[1])
    mask2 = bmask(locs[2])
    mask12 = mask1 | mask2
    a = T(cos(theta / 2))
    c = T(-im * sin(theta / 2))
    e = T(exp(-im / 2 * theta))
    @threads for b in basis(state)
        if b & mask1 == 0
            i = b + 1
            i_ = b ⊻ mask12 + 1
            if b & mask2 == mask2
                u1rows!(state, i, i_, a, c, c, a)
            else
                mulrow!(state, i, e)
                mulrow!(state, i_, e)
            end
        end
    end
    return state
end

function YaoAPI.instruct!(::Val{2},
    state::AbstractVecOrMat{T},
    ::Val{:PSWAP},
    locs::Tuple{Int,Int},
    control_locs::NTuple{C,Int},
    control_bits::NTuple{C,Int},
    theta::Number,
) where {T,C}
    mask1 = bmask(locs[1])
    mask2 = bmask(locs[2])
    mask12 = mask1 | mask2
    a = T(cos(theta / 2))
    c = T(-im * sin(theta / 2))
    e = T(exp(-im / 2 * theta))
    @threads for b in itercontrol(
        log2i(size(state, 1)),
        collect(Int, control_locs),
        collect(Int, control_bits),
    )
        if b & mask1 == 0
            i = b + 1
            i_ = b ⊻ mask12 + 1
            if b & mask2 == mask2
                u1rows!(state, i, i_, a, c, c, a)
            else
                mulrow!(state, i, e)
                mulrow!(state, i_, e)
            end
        end
    end
    return state
end

using Test, YaoAPI, YaoArrayRegister, LinearAlgebra, LuxurySparse, SparseArrays
#using YaoArrayRegister.Const
using YaoArrayRegister: linop2dense, general_controlled_gates, parametric_mat

# NOTE: we don't have block here, feel safe to use

@testset "test general unitary instruction" begin
    U1 = randn(ComplexF64, 2, 2)
    ST = randn(ComplexF64, 1 << 4)
    REG = ArrayReg(ST)
    I2 = IMatrix(2)
    M = kron(I2, U1, I2, I2) * ST

    @test instruct!(Val(2), copy(ST), U1, (3,)) ≈ M ≈ instruct!(Val(2), reshape(copy(ST), :, 1), U1, (3,))

    U2 = rand(ComplexF64, 4, 4)
    M = kron(I2, U2, I2) * ST
    @test instruct!(Val(2), copy(ST), U2, (2, 3)) ≈ M

    @test instruct!(Val(2), copy(ST), kron(U1, U1), (3, 1)) ≈
          instruct!(Val(2), instruct!(Val(2), copy(ST), U1, (3,)), U1, (1,))
    @test instruct!(copy(REG), kron(U1, U1), (3, 1)) ≈
          instruct!(instruct!(copy(REG), U1, (3,)), U1, (1,))
    @test instruct!(transpose_storage(REG), kron(U1, U1), (3, 1)) ≈
          instruct!(instruct!(copy(REG), U1, (3,)), U1, (1,))
    @test instruct!(transpose_storage(REG), kron(U1, U1), (3, 1)) ≈
          instruct!(instruct!(transpose_storage(REG), U1, (3,)), U1, (1,))

    @test instruct!(Val(2), reshape(copy(ST), :, 1), kron(U1, U1), (3, 1)) ≈
          instruct!(Val(2), instruct!(Val(2), reshape(copy(ST), :, 1), U1, (3,)), U1, (1,))

    U2 = sprand(ComplexF64, 8, 8, 0.1)
    ST = randn(ComplexF64, 1 << 5)
    M = kron(I2, U2, I2) * ST
    @test instruct!(Val(2), copy(ST), U2, (2, 3, 4)) ≈ M

    @test instruct!(Val(2), copy(ST), I2, (1,)) ≈ ST
    @test instruct!(Val(2), copy(ST), IMatrix(4), (2,3)) ≈ ST

    STB = randn(ComplexF64, 2 ^ 4, 5)
    U1 = randn(ComplexF64, 2, 2)
    REGB = BatchedArrayReg(STB, 5)
    @test instruct!(copy(REGB), U1, (3,)).state ≈ instruct!(Val(2), copy(STB), U1, (3,)) ≈ instruct!(Val(2), copy(STB), U1, (3,), (), ())
    @test instruct!(arrayreg(copy(STB); nbatch=5), randn(ComplexF64, 2, 2), ()) |> state ≈ STB

    # PermMatrix
    U1 = PermMatrix([0.0 -1.0im; 1.0im 0.0im])
    @test instruct!(copy(REGB), U1, (3,)).state ≈ instruct!(copy(REGB), Val(:Y), (3,)).state
    @test instruct!(copy(REGB), Diagonal([1.0, im]), (3,)).state ≈ instruct!(copy(REGB), Val(:S), (3,)).state
end

@testset "test auto conversion" begin
    v = rand(ComplexF32, 1 << 8)
    if VERSION < v"1.6-"
        @test_logs (
            :warn,
            "Element Type Mismatch: register Complex{Float32}, operator Complex{Float64}. Converting operator to match, this may cause performance issue",
        ) instruct!(arrayreg(v), Const.CNOT, (1, 2))
    else
        @test_logs (
            :warn,
            "Element Type Mismatch: register ComplexF32, operator ComplexF64. Converting operator to match, this may cause performance issue",
        ) instruct!(arrayreg(v), Const.CNOT, (1, 2))
    end
end


@testset "test general control unitary operator" begin
    ST = randn(ComplexF64, 1 << 5)
    U1 = randn(ComplexF64, 2, 2)
    instruct!(Val(2), copy(ST), U1, (3,), (1,), (1,))

    @test instruct!(Val(2), copy(ST), U1, (3,), (1,), (1,)) ≈
          general_controlled_gates(5, [Const.P1], [1], [U1], [3]) * ST
    @test instruct!(Val(2), copy(ST), U1, (3,), (1,), (0,)) ≈
          general_controlled_gates(5, [Const.P0], [1], [U1], [3]) * ST

    # control U2
    U2 = kron(U1, U1)
    @test instruct!(Val(2), copy(ST), U2, (3, 4), (1,), (1,)) ≈
          general_controlled_gates(5, [Const.P1], [1], [U2], [3]) * ST

    # multi-control U2
    @test instruct!(Val(2), copy(ST), U2, (3, 4), (5, 1), (1, 0)) ≈
          general_controlled_gates(5, [Const.P1, Const.P0], [5, 1], [U2], [3]) * ST
end


@testset "test Pauli instructions" begin
    @testset "test $G instructions" for (G, M) in zip((:X, :Y, :Z), (Const.X, Const.Y, Const.Z))
        @test linop2dense(s -> instruct!(Val(2), s, Val(G), (1,)), 1) == M
        @test linop2dense(s -> instruct!(Val(2), s, Val(G), (1, 2, 3)), 3) == kron(M, M, M)
    end

    @testset "test controlled $G instructions" for (G, M) in zip((:X, :Y, :Z), (Const.X, Const.Y, Const.Z))
        @test linop2dense(s -> instruct!(Val(2), s, Val(G), (4,), (2, 1), (0, 1)), 4) ≈
              general_controlled_gates(4, [Const.P0, Const.P1], [2, 1], [M], [4])

        @test linop2dense(s -> instruct!(Val(2), s, Val(G), (1,), (2,), (0,)), 2) ≈
              general_controlled_gates(2, [Const.P0], [2], [M], [1])
    end
end

@testset "single qubit instruction" begin
    ST = randn(ComplexF64, 1 << 4)
    Pm = pmrand(ComplexF64, 2)
    Dv = Diagonal(randn(ComplexF64, 2))

    @test instruct!(Val(2), copy(ST), Pm, (3,)) ≈
          kron(Const.I2, Pm, Const.I2, Const.I2) * ST ≈
          instruct!(Val(2), reshape(copy(ST), :, 1), Pm, (3,))
    @test instruct!(Val(2), copy(ST), Dv, (3,)) ≈
          kron(Const.I2, Dv, Const.I2, Const.I2) * ST ≈
          instruct!(Val(2), reshape(copy(ST), :, 1), Dv, (3,))
end

@testset "swap instruction" begin
    ST = randn(ComplexF64, 1 << 2)
    @test instruct!(Val(2), copy(ST), Val(:SWAP), (1, 2)) ≈ Const.SWAP * ST
end

@testset "pswap instruction" begin
    ST = randn(ComplexF64, 1 << 2)
    θ = π / 3
    @test instruct!(Val(2), copy(ST), Val(:PSWAP), (1, 2), θ) ≈
          (cos(θ / 2) * IMatrix(4) - im * sin(θ / 2) * Const.SWAP) * ST

    T = ComplexF64
    theta = 0.5
    for (R, G) in [(:Rx, Const.X), (:Ry, Const.Y), (:Rz, Const.Z), (:PSWAP, Const.SWAP)]
        @test parametric_mat(T, Val(R), theta) ≈ rot_mat(T, G, theta)
    end
    @test parametric_mat(T, Val(:CPHASE), theta) ≈
          rot_mat(T, Diagonal([1, 1, 1, -1]), theta) * exp(im * theta / 2)
    for ST in [randn(ComplexF64, 1 << 5), randn(ComplexF64, 1 << 5, 10)]
        @test instruct!(Val(2), copy(ST), Val(:H), (4,)) ≈ instruct!(Val(2), copy(ST), Const.H, (4,))
        for R in [:Rx, :Ry, :Rz]
            @test instruct!(Val(2), copy(ST), Val(R), (4,), θ) ≈
                  instruct!(Val(2), copy(ST), Matrix(parametric_mat(T, Val(R), θ)), (4,))
            @test instruct!(Val(2), copy(ST), Val(R), (4,), (1,), (0,), θ) ≈
                  instruct!(Val(2), copy(ST), Matrix(parametric_mat(T, Val(R), θ)), (4,), (1,), (0,))
        end
        for R in [:CPHASE, :PSWAP]
            @test instruct!(Val(2), copy(ST), Val(R), (4, 2), θ) ≈
                  instruct!(Val(2), copy(ST), Matrix(parametric_mat(T, Val(R), θ)), (4, 2))
            instruct!(Val(2), copy(ST), Val(R), (4, 2), (1,), (0,), θ)
            instruct!(Val(2), copy(ST), Matrix(parametric_mat(T, Val(R), θ)), (4, 2), (1,), (0,))
            @test instruct!(Val(2), copy(ST), Val(R), (4, 2), (1,), (0,), θ) ≈
                  instruct!(Val(2), copy(ST), Matrix(parametric_mat(T, Val(R), θ)), (4, 2), (1,), (0,))
        end
    end
end

@testset "Yao.jl/#189" begin
    st = rand(1 << 4)
    @test instruct!(Val(2), st, IMatrix{Float64}(2), (1,)) == st
end

@testset "test empty locs" begin
    st = rand(ComplexF64, 1 << 4)
    pm = pmrand(ComplexF64, 2)
    @test instruct!(arrayreg(copy(st)), pm, ()) |> statevec == st

    for G in [:Z, :S, :T, :Sdag, :Tdag]
        @test instruct!(arrayreg(copy(st)), Val(G), ()) |> statevec == st
    end
end

@testset "register insterface" begin
    r = rand_state(5)
    @test instruct!(copy(r), Val(:X), (2,)).state ≈ instruct!(Val(2), copy(r.state), Val(:X), (2,))
    @test instruct!(copy(r), Val(:X), (2,), (3,), (1,)).state ≈
          instruct!(Val(2), copy(r.state), Val(:X), (2,), (3,), (1,))
    @test instruct!(copy(r), Val(:Rx), (2,), 0.5).state ≈
          instruct!(Val(2), copy(r.state), Val(:Rx), (2,), 0.5)
    @test instruct!(copy(r), Val(:Rx), (2,), (3,), (1,), 0.5).state ≈
          instruct!(Val(2), copy(r.state), Val(:Rx), (2,), (3,), (1,), 0.5)
end


@testset "regression test, rot CNOT - please run with multi-threading" begin
    g = [
        0.921061-0.389418im 0.0+0.0im 0.0+0.0im 0.0+0.0im
        0.0+0.0im 0.921061-0.0im 0.0+0.0im 0.0-0.389418im
        0.0+0.0im 0.0+0.0im 0.921061-0.389418im 0.0+0.0im
        0.0+0.0im 0.0-0.389418im 0.0+0.0im 0.921061-0.0im
    ]
    n = 16
    gs = sparse(g)
    reg1 = rand_state(n)
    reg2 = copy(reg1)
    for i = 1:50
        x1 = rand(1:n)
        x2 = rand(1:n-1)
        x2 = x2 >= x1 ? x2 + 1 : x2
        instruct!(reg1, g, (x1, x2))
        instruct!(reg2, gs, (x1, x2))
    end
    @test isapprox(norm(statevec(reg1)), 1.0; atol = 1e-5)
    @test isapprox(norm(statevec(reg2)), 1.0; atol = 1e-5)
    @test isapprox(statevec(reg1), statevec(reg2))
end

@testset "push coverage" begin
    state = randn(ComplexF64, 3^5)
    # identity fallback
    @test instruct!(Val(3), copy(state), IMatrix{ComplexF64}(3), (1,)) == state
    U = randn(ComplexF64,3,3)
    # error on control
    @test_throws ErrorException instruct!(Val(3), state, U, (1,), (2,), (4,))
    @test instruct!(Val(3), copy(state), U, (1,), (), ()) ≈ instruct!(Val(3), copy(state), U, (1,))
    U2 = randn(ComplexF64,9,9)
    @test instruct!(Val(3), copy(state), U2, (3,1), (), ()) ≈ instruct!(Val(3), copy(state), U2, (3,1))
end

@testset "density matrix instruct" begin
    for G in [pmrand(ComplexF64,4), Diagonal(randn(ComplexF64,4)), sprand(ComplexF64,4,4,0.5), IMatrix(4)]
        reg = rand_state(8)
        reg1 = instruct!(copy(reg), G, (4,2), (1,), (0,))
        r = density_matrix(reg)
        instruct!(r, G, (4,2), (1,), (0,))
        @test r ≈ density_matrix(reg1)
    end
    for G in [:X, :Y, :Z, :S, :T, :Sdag, :Tdag, :H]
        reg = rand_state(8)
        reg1 = instruct!(copy(reg), Val(G), (4,))
        r = density_matrix(reg)
        instruct!(r, Val(G), (4,))
        @test r ≈ density_matrix(reg1)
    end
    for G in [:SWAP]
        reg = rand_state(8)
        reg1 = instruct!(copy(reg), Val(G), (4,2))
        r = density_matrix(reg)
        instruct!(r, Val(G), (4,2))
        @test r ≈ density_matrix(reg1)
    end
    for G in [:CPHASE, :PSWAP]
        reg = rand_state(8)
        reg1 = instruct!(copy(reg), Val(G), (4,2), 0.5)
        r = density_matrix(reg)
        instruct!(r, Val(G), (4,2), 0.5)
        @test r ≈ density_matrix(reg1)
    end
    for G in [:Rx, :Ry, :Rz]
        reg = rand_state(8)
        reg1 = instruct!(copy(reg), Val(G), (4,), 0.5)
        r = density_matrix(reg)
        instruct!(r, Val(G), (4,), 0.5)
        @test r ≈ density_matrix(reg1)
    end
end

YaoAPI.NotImplementedError(name::Symbol) = NotImplementedError(name, ())

function Base.show(io::IO, e::NotImplementedError)
    str = join(map(typeof, e.args), ", ::")
    str = "::" * str
    print(
        io,
        "NotImplementedError: $(e.name) is not implemented for (",
        str,
        "), ",
        "please implement this method for your custom type",
    )
end

function Base.show(io::IO, e::NotImplementedError{Tuple{}})
    print(io, "$(e.name) is not implemented.")
end

function Base.show(io::IO, e::LocationConflictError)
    print(io, "LocationConflictError: ", e.msg)
    # print(io, "locations of $(e.blk1) and $(e.blk2) is conflict.")
end

function Base.show(io::IO, e::QubitMismatchError)
    print(io, e.msg)
end


_sort(x::Vector; by = identity) = sort(x, by = by)
_sort(x::Tuple; by = identity) = TupleTools.sort(x, by = by)

# NOTE: this method assumes its input is not empty, it gets rid of errors
nonempty_minimum(x::UnitRange) = x.start
nonempty_minimum(x::Integer) = x
nonempty_maximum(x::UnitRange) = x.stop
nonempty_maximum(x::Integer) = x

const AddressVector{T} = Vector{T} where {T<:Union{Integer,UnitRange}}
const AddressNTuple{N,T} = NTuple{N,T} where {T<:Union{Integer,UnitRange}}
const AddressList{T} = Union{AddressVector{T},AddressNTuple{N,T} where N}

"""
    islocs_inbounds(n, locs) -> Bool

Check if the input locations are inside given bounds `n`.
"""
function islocs_inbounds(n::Int, locs::AddressList)
    length(locs) == 0 && return true
    locs = _sort(locs, by = x -> nonempty_minimum(x))
    (minimum(first(locs)) > 0 && maximum(last(locs)) <= n) || return false
    return true
end

"""
    islocs_conflict(locs) -> Bool

Check if the input locations has conflicts.
"""
function islocs_conflict(locs::AddressList)
    locs = _sort(locs)
    for i = 1:length(locs)-1
        nonempty_minimum(locs[i+1]) > nonempty_maximum(locs[i]) || return true
    end
    return false
end

function process_msgs(msgs...; default = "")
    msg = isempty(msgs) ? default : msgs[1]
    if isa(msg, AbstractString)
        msg = msg # pass-through
    elseif !isempty(msgs) && (isa(msg, Expr) || isa(msg, Symbol))
        # message is an expression needing evaluating
        msg = :(Main.Base.string($(esc(msg))))
    elseif isdefined(Main, :Base) &&
           isdefined(Main.Base, :string) &&
           applicable(Main.Base.string, msg)
        msg = Main.Base.string(msg)
    else
        # string() might not be defined during bootstrap
        msg = :(Main.Base.string($(Expr(:quote, msg))))
    end
    return msg
end


# NOTE: we may use @assert in the future
#       these macro will help us keep original APIs

"""
    @assert_locs_inbounds <number of total qudits> <locations list> [<msg>]

Assert if all the locations are inbounds.
"""
macro assert_locs_inbounds(n, locs, msgs...)
    msg = process_msgs(msgs...; default = "locations is out of bounds!")

    return quote
        islocs_inbounds($(esc(n)), $(esc(locs))) || error($msg)
        nothing
    end
end

"""
    @assert_locs_safe <number of total qudits> <locations list> [<msg>]

Assert if all the locations are:
    - inbounds.
    - do not have any conflict.
"""
macro assert_locs_safe(n, locs, msgs...)
    msg = process_msgs(msgs...; default = "locations conflict.")
    return quote
        @assert_locs_inbounds $(esc(n)) $(esc(locs))
        islocs_conflict($(esc(locs))) && throw(LocationConflictError($msg))
        nothing
    end
end

using LuxurySparse
using TupleTools
@static if hasmethod(TupleTools.diff, Tuple{Tuple{}})
    tuple_diff(args...) = TupleTools.diff(args...)
else
    tuple_diff(v::Tuple{}) = () # similar to diff([])
    tuple_diff(v::Tuple{Any}) = ()
    tuple_diff(v::Tuple) = (v[2] - v[1], tuple_diff(Base.tail(v))...)
end

"""
    sort_unitary(::Val{D}, U, locations::NTuple{N, Int}) -> U

Return an sorted unitary operator according to the locations.
"""
function sort_unitary(::Val{D}, U::AbstractMatrix, locs::NTuple{N,Int}) where {D,N}
    if all(each > 0 for each in tuple_diff(locs))
        return U
    else
        pm = TupleTools.sortperm(TupleTools.sortperm(locs))
        return reshape(permutedims(reshape(U, fill(D, 2*N)...), (pm..., pm .+ N...)), size(U))
    end
end

"""
    swaprows!(v::VecOrMat, i::Int, j::Int[, f1, f2]) -> VecOrMat

swap row i and row j of v inplace, with f1, f2 factors applied on i and j (before swap).
"""
function swaprows! end

Base.@propagate_inbounds function swaprows!(
    v::AbstractMatrix{T},
    i::Int,
    j::Int,
    f1,
    f2,
) where {T}
    for c = 1:size(v, 2)
        temp = v[i, c]
        v[i, c] = v[j, c] * f2
        v[j, c] = temp * f1
    end
    v
end

Base.@propagate_inbounds function swaprows!(v::AbstractMatrix{T}, i::Int, j::Int) where {T}
    for c = 1:size(v, 2)
        temp = v[i, c]
        v[i, c] = v[j, c]
        v[j, c] = temp
    end
    v
end

"""
    swapcols!(v::VecOrMat, i::Int, j::Int[, f1, f2]) -> VecOrMat

swap col i and col j of v inplace, with f1, f2 factors applied on i and j (before swap).
"""
function swapcols! end

Base.@propagate_inbounds function swapcols!(
    v::AbstractMatrix{T},
    i::Int,
    j::Int,
    f1,
    f2,
) where {T}
    for c = 1:size(v, 1)
        temp = v[c, i]
        v[c, i] = v[c, j] * f2
        v[c, j] = temp * f1
    end
    v
end

Base.@propagate_inbounds function swapcols!(v::AbstractMatrix{T}, i::Int, j::Int) where {T}
    for c = 1:size(v, 1)
        temp = v[c, i]
        v[c, i] = v[c, j]
        v[c, j] = temp
    end
    v
end

Base.@propagate_inbounds swapcols!(v::AbstractVector, args...) = swaprows!(v, args...)

Base.@propagate_inbounds function swaprows!(v::AbstractVector, i::Int, j::Int, f1, f2)
    temp = v[i]
    v[i] = v[j] * f2
    v[j] = temp * f1
    v
end

Base.@propagate_inbounds function swaprows!(v::AbstractVector, i::Int, j::Int)
    temp = v[i]
    v[i] = v[j]
    v[j] = temp
    v
end

"""
    u1rows!(state::VecOrMat, i::Int, j::Int, a, b, c, d) -> VecOrMat

apply u1 on row i and row j of state inplace.
"""
function u1rows! end

Base.@propagate_inbounds function u1rows!(state::AbstractVector, i::Int, j::Int, a, b, c, d)
    w = state[i]
    v = state[j]
    state[i] = a * w + b * v
    state[j] = c * w + d * v
    state
end

Base.@propagate_inbounds function u1rows!(state::AbstractMatrix, i::Int, j::Int, a, b, c, d)
    for col = 1:size(state, 2)
        w = state[i, col]
        v = state[j, col]
        state[i, col] = a * w + b * v
        state[j, col] = c * w + d * v
    end
    state
end

"""
    mulrow!(v::AbstractVector, i::Int, f) -> VecOrMat

multiply row i of v by f inplace.
"""
function mulrow! end

Base.@propagate_inbounds function mulrow!(v::AbstractVector, i::Int, f)
    v[i] *= f
    return v
end

Base.@propagate_inbounds function mulrow!(v::AbstractMatrix, i::Int, f)
    for j = 1:size(v, 2)
        v[i, j] *= f
    end
    return v
end

"""
    mulcol!(v::AbstractVector, i::Int, f) -> VecOrMat

multiply col i of v by f inplace.
"""
function mulcol! end

Base.@propagate_inbounds function mulcol!(v::AbstractVector, i::Int, f)
    v[i] *= f
    return v
end

Base.@propagate_inbounds function mulcol!(v::AbstractMatrix, j::Int, f)
    for i = 1:size(v, 1)
        v[i, j] *= f
    end
    return v
end

"""
    matvec(x::VecOrMat) -> MatOrVec

Return vector if a matrix is a column vector, else untouched.
"""
function matvec end

matvec(x::AbstractMatrix) = size(x, 2) == 1 ? vec(x) : x
matvec(x::AbstractVector) = x

Base.@propagate_inbounds function unrows!(
    state::AbstractVector,
    inds::AbstractVector,
    U::AbstractMatrix,
)
    state[inds] = U * state[inds]
    return state
end

Base.@propagate_inbounds function unrows!(
    state::AbstractMatrix,
    inds::AbstractVector,
    U::AbstractMatrix,
)
    for k = 1:size(state, 2)
        state[inds, k] = U * state[inds, k]
    end
    return state
end

############# boost unrows! for sparse matrices ################
@inline unrows!(state::AbstractVector, inds::AbstractVector, U::IMatrix) = state

Base.@propagate_inbounds function unrows!(
    state::AbstractVector,
    inds::AbstractVector,
    U::SDDiagonal,
)
    for i = 1:length(U.diag)
        state[inds[i]] *= U.diag[i]
    end
    return state
end

Base.@propagate_inbounds function unrows!(
    state::AbstractMatrix,
    inds::AbstractVector,
    U::SDDiagonal,
)
    for j = 1:size(state, 2)
        for i = 1:length(U.diag)
            state[inds[i], j] *= U.diag[i]
        end
    end
    state
end

Base.@propagate_inbounds function unrows!(
    state::AbstractVector,
    inds::AbstractVector,
    U::SDPermMatrix,
)
    state[inds] = state[inds[U.perm]] .* U.vals
    state
end

Base.@propagate_inbounds function unrows!(
    state::AbstractMatrix,
    inds::AbstractVector,
    U::SDPermMatrix,
)
    for k = 1:size(state, 2)
        state[inds, k] = state[inds[U.perm], k] .* U.vals
    end
    state
end

Base.@propagate_inbounds function unrows!(
    state::AbstractVector,
    inds::AbstractVector,
    A::SDSparseMatrixCSC,
    work::AbstractVector,
)
    work .= 0
    for col = 1:length(inds)
        xj = state[inds[col]]
        for j = A.colptr[col]:(A.colptr[col+1]-1)
            work[A.rowval[j]] += A.nzval[j] * xj
        end
    end
    state[inds] = work
    state
end

Base.@propagate_inbounds function unrows!(
    state::AbstractMatrix,
    inds::AbstractVector,
    A::SDSparseMatrixCSC,
    work::Matrix,
)
    work .= 0
    for k = 1:size(state, 2)
        for col = 1:length(inds)
            xj = state[inds[col], k]
            for j = A.colptr[col]:(A.colptr[col+1]-1)
                work[A.rowval[j], k] += A.nzval[j] * xj
            end
        end
        state[inds, k] = view(work, :, k)
    end
    state
end

using LinearAlgebra: Transpose
Base.convert(::Type{Transpose{T,Matrix{T}}}, arr::AbstractMatrix{T}) where {T} =
    transpose(Matrix(transpose(arr)))
Base.convert(t::Type{Transpose{T,Matrix{T}}}, arr::Transpose{T}) where {T} =
    invoke(convert, Tuple{Type{Transpose{T,Matrix{T}}},Transpose}, t, arr)

function ispow(x::Integer, d::Integer)
    r = log(x) / log(d)
    return round(Int, r) ≈ r
end

"""
    batch_normalize!(matrix)

normalize a batch of vector.
"""
function batch_normalize!(s::AbstractMatrix, p::Real = 2)
    B = size(s, 2)
    for i = 1:B
        normalize!(view(s, :, i), p)
    end
    s
end

"""
    batch_normalize

normalize a batch of vector.
"""
function batch_normalize(s::AbstractMatrix, p::Real = 2)
    ts = copy(s)
    batch_normalize!(ts, p)
end

# computes the trace norm of a matrix `m`.
trace_norm(m::AbstractMatrix) = nuclear_norm(m)
# computes the nuclear norm of a matrix `m`.
function nuclear_norm(m::AbstractMatrix)
    norm(svdvals(m), 1)
end

# ``\log_d(x)``
function logdi(x::Integer, d::Integer)
    @assert x > 0 && d > 0
    res = log(x) / log(d)
    r = round(Int, res)
    if !(res ≈ r)
        throw(ArgumentError("`$x` is not an integer power of `$d`."))
    end
    return r
end

"""
    autostatic(A[; threshold=8])

Staticize dynamic array `A` by a `threshold`.
"""
autostatic(A::AbstractVecOrMat; threshold::Int = 8) =
    length(A) > (1 << threshold) ? A : staticize(A)

################### Fidelity ###################
"""
    density_matrix_fidelity(ρ, σ)

General fidelity (including mixed states) between two density matrix for qudits.

### Definition

```math
F(\\rho, \\sigma) = {\\rm Tr}\\sqrt{\\sqrt{\\rho}\\sigma\\sqrt{\\rho}}
```
"""
function density_matrix_fidelity(ρ::AbstractMatrix, σ::AbstractMatrix)
    E1, U1 = eigen(Hermitian(ρ))
    E2, U2 = eigen(Hermitian(σ))
    E1 .= max.(E1, zero(eltype(E1)))
    E2 .= max.(E2, zero(eltype(E2)))
    sq1 = U1 * Diagonal(sqrt.(E1)) * U1'
    sq2 = U2 * Diagonal(sqrt.(E2)) * U2'
    return sum(svd(sq1 * sq2).S)
end


"""
    pure_state_fidelity(v1::Vector, v2::Vector)

fidelity for pure states.
"""
pure_state_fidelity(v1::AbstractVector, v2::AbstractVector) = abs(v1' * v2)

"""
    purification_fidelity(m1::Matrix, m2::Matrix)

Fidelity for mixed states via purification.

Reference:
    http://iopscience.iop.org/article/10.1088/1367-2630/aa6a4b/meta
"""
function purification_fidelity(m1::Matrix, m2::Matrix)
    O = m1' * m2
    return sum(svd(O).S)
end

"""
    linop2dense([T=ComplexF64], linear_map!::Function, n::Int; nlevel=2) -> Matrix

Returns the dense matrix representation given linear map function.
"""
linop2dense(linear_map!::Function, n::Int; nlevel=2) = linop2dense(ComplexF64, linear_map!, n; nlevel=nlevel)
linop2dense(::Type{T}, linear_map!::Function, n::Int; nlevel=2) where {T} =
    linear_map!(Matrix{T}(I, nlevel ^ n, nlevel ^ n))

"""
    general_controlled_gates(num_bit::Int, projectors::Vector{Tp}, cbits::Vector{Int}, gates::Vector{AbstractMatrix}, locs::Vector{Int}) -> AbstractMatrix

Return general multi-controlled gates in hilbert space of `num_bit` qudits,

* `projectors` are often chosen as `P0` and `P1` for inverse-Control and Control at specific position.
* `cbits` should have the same length as `projectors`, specifing the controling positions.
* `gates` are a list of controlled single qubit gates.
* `locs` should have the same length as `gates`, specifing the gates positions.
"""
function general_controlled_gates(
    n::Int,
    projectors::Vector{<:AbstractMatrix},
    cbits::Vector{Int},
    gates::Vector{<:AbstractMatrix},
    locs::Vector{Int},
)
    IMatrix(1 << n) - hilbertkron(n, projectors, cbits) +
    hilbertkron(n, vcat(projectors, gates), vcat(cbits, locs))
end

"""
    hilbertkron(num_bit::Int, gates::Vector{AbstractMatrix}, locs::Vector{Int}; nlevel=2) -> AbstractMatrix

Return general kronecher product form of gates in Hilbert space of `num_bit` qudits.

* `gates` are a list of matrices.
* `start_locs` should have the same length as `gates`, specifing the gates starting positions.
"""
function hilbertkron(num_bit::Int, ops::Vector{<:AbstractMatrix}, start_locs::Vector{Int}; nlevel=2)
    sizes = [logdi(size(op, 1), nlevel) for op in ops]
    start_locs = num_bit .- start_locs .- sizes .+ 2

    order = sortperm(start_locs)
    sorted_ops = ops[order]
    sorted_start_locs = start_locs[order]
    num_ids = vcat(
        sorted_start_locs[1] - 1,
        diff(push!(sorted_start_locs, num_bit + 1)) .- sizes[order],
    )

    _wrap_identity(sorted_ops, num_ids, nlevel)
end
diff(v::AbstractVector) = Base.diff(v)
diff(v::Tuple) = TupleTools.diff(v)

# kron, and wrap matrices with identities.
function _wrap_identity(
    data_list::Vector{T},
    num_bit_list::Vector{Int},
    nlevel
) where {T<:AbstractMatrix}
    length(num_bit_list) == length(data_list) + 1 || throw(ArgumentError())
    reduce(
        zip(data_list, num_bit_list[2:end]);
        init = IMatrix(nlevel ^ num_bit_list[1]),
    ) do x, y
        fastkron(fastkron(x, y[1]), IMatrix(nlevel ^ y[2]))
    end
end

batched_kron(a, b, c, xs...) =
    Base.afoldl(batched_kron, (batched_kron)((batched_kron)(a, b), c), xs...)

function batched_kron(A::AbstractArray{T,3}, B::AbstractArray{S,3}) where {T,S}
    @assert size(A, 3) == size(B, 3) "batch size mismatch"
    C = Array{Base.promote_op(*, T, S),3}(
        undef,
        size(A, 1) * size(B, 1),
        size(A, 2) * size(B, 2),
        size(A, 3),
    )
    return batched_kron!(C, A, B)
end

function batched_kron!(
    C::Array{T,3},
    A::AbstractArray{T1,3},
    B::AbstractArray{T2,3},
) where {T,T1,T2}
    @assert !Base.has_offset_axes(A, B)
    m, n = size(A)
    p, q = size(B)
    @inbounds for k = 1:size(C, 3)
        for s = 1:n, r = 1:m, w = 1:q, v = 1:p
            C[p*(r-1)+v, q*(s-1)+w, k] = A[r, s, k] * B[v, w, k]
        end
    end
    return C
end

@static if !@isdefined(kron!)
    export kron!
    # NOTE: JuliaLang/julia/pull/31069 includes this function
    function kron!(
        C::AbstractMatrix{T},
        A::AbstractMatrix{T1},
        B::AbstractMatrix{T2},
    ) where {T,T1,T2}
        @assert !Base.has_offset_axes(A, B)
        m = 1
        @inbounds for j = 1:size(A, 2), l = 1:size(B, 2), i = 1:size(A, 1)
            aij = A[i, j]
            for k = 1:size(B, 1)
                C[m] = aij * B[k, l]
                m += 1
            end
        end
        return C
    end
end

function matchtype(::Type{T}, A::AbstractArray{T2}) where {T,T2}
    return copyto!(similar(A, T), A)
end
function matchtype(::Type{T}, A::AbstractArray{T}) where {T}
    return A
end

@static if !hasmethod(IMatrix{Float64}, Tuple{Int})
    LuxurySparse.IMatrix{T}(n::Int) where T = IMatrix{n,T}()
end

"""
    Const

Contains common constant definitions.
"""
module Const

using LuxurySparse, LinearAlgebra, SparseArrays
using YaoArrayRegister.ASTTools

"""
    @def name = value

Define a constant and export it.
"""
macro def(ex)
    list = @capture($name = $m)(ex)
    quote
        export $(esc(list[:name]))
        Core.@__doc__ const $(esc(list[:name])) = $(list[:m])
    end
end

@def P0 = Diagonal(ComplexF64[1, 0])
@def P1 = Diagonal(ComplexF64[0, 1])
@def X = PermMatrix([2, 1], ComplexF64[1+0im, 1])
@def Y = PermMatrix([2, 1], ComplexF64[-im, im])
@def Z = Diagonal(ComplexF64[1+0im, -1])
@def S = Diagonal(ComplexF64[1, im])
@def Sdag = Diagonal(ComplexF64[1, -im])
@def T = Diagonal(ComplexF64[1, exp(π * im / 4)])
@def Tdag = Diagonal(ComplexF64[1, exp(-π * im / 4)])
@def I2 = IMatrix{ComplexF64}(2)
@def H = (elem = 1 / sqrt(2); ComplexF64[elem elem; elem -elem])
@def CNOT = PermMatrix([1, 4, 3, 2], ones(ComplexF64, 4))
@def CZ = Diagonal([1.0 + 0im, 1, 1, -1])
@def SWAP = PermMatrix([1, 3, 2, 4], ones(ComplexF64, 4))
@def Toffoli = PermMatrix([1, 2, 3, 8, 5, 6, 7, 4], ones(ComplexF64, 8))
@def Pu = sparse([1], [2], ComplexF64[1+0im], 2, 2)
@def Pd = sparse([2], [1], ComplexF64[1+0im], 2, 2)

end

using Test, YaoArrayRegister
using LinearAlgebra

@testset "test fidelity" begin
    reg = rand_state(3)
    reg_ = rand_state(3)
    reg2 = clone(reg, 3)
    @test fidelity(reg, reg) ≈ 1
    @test fidelity(reg, reg_) < 1
    @test fidelity(reg2, reg2) ≈ [1, 1, 1]

    # mix
    reg4 = join(reg, reg)
    reg5 = join(reg_, reg_)
    focus!(reg4, 1:3)
    focus!(reg5, 1:3)
    @test isapprox(fidelity(reg, reg_), fidelity(reg4, reg5), atol = 1e-5)

    @test isapprox.(
        fidelity(reg, reg_),
        fidelity(clone(reg4, 3), clone(reg5, 3)),
        atol = 1e-5,
    ) |> all

    # batch
    st = rand(ComplexF64, 8, 2)
    reg1 = BatchedArrayReg(st)
    reg2 = rand_state(3)

    @test fidelity(reg1, reg2) ≈
          [fidelity(ArrayReg(st[:, 1]), reg2), fidelity(ArrayReg(st[:, 2]), reg2)]

    @test isapprox.(
        fidelity(reg, reg_),
        fidelity(clone(reg4, 3), clone(reg5, 3)),
        atol = 1e-5,
    ) |> all
end

@testset "test trace distance" begin
    reg = rand_state(3)
    reg_ = rand_state(3)
    reg2 = clone(reg, 3)
    dm = density_matrix(reg)
    dm_ = density_matrix(reg_)
    dm2s = density_matrix.(reg2)
    @test reg |> probs ≈ dm |> probs
    @test isapprox(tracedist(dm, dm), tracedist(reg, reg), atol = 1e-5)
    @test isapprox(tracedist(dm, dm_), tracedist(reg, reg_), atol = 1e-5)
    @test isapprox(tracedist.(dm2s, dm2s), tracedist(reg2, reg2), atol = 1e-5)

    # mix
    reg4 = join(reg, reg)
    reg5 = join(reg_, reg_)
    focus!(reg4, 1:3)
    focus!(reg5, 1:3)
    dm4 = reg4 |> density_matrix
    dm5 = reg5 |> density_matrix
    @test nqubits(dm4) == 3
    @test isapprox(tracedist(dm, dm_)[], tracedist(dm4, dm5)[], atol = 1e-5)
    @test isapprox.(
        tracedist(dm, dm_)[],
        tracedist.(clone(reg4, 3) .|> density_matrix, clone(reg5, 3) .|> density_matrix),
        atol = 1e-5,
    ) |> all
end

@testset "purify" begin
    reg = rand_state(6)
    reg_p = purify(reg |> density_matrix)
    @test reg_p |> isnormalized
    @test reg_p |> exchange_sysenv |> probs |> maximum ≈ 1
    reg_p = purify(reg |> density_matrix; num_env = 0)
    @test fidelity(reg, reg_p) ≈ 1

    reg = rand_state(6; nbatch = 10)
    reg_p = BatchedArrayReg(purify.(reg .|> density_matrix)...)
    @test reg_p |> isnormalized
    @test reg_p |> exchange_sysenv |> probs |> maximum ≈ 1
    reg_p = BatchedArrayReg(purify.(reg .|> density_matrix; num_env = 0)...)
    @test fidelity(reg, reg_p) ≈ ones(10)
    reg_p = BatchedArrayReg(purify.(reg .|> density_matrix; num_env = 2)...)
    @test reg_p |> nqubits == 8
end

@testset "reduce density matrix" begin
    reg = ghz_state(4)
    rdm = density_matrix(reg, (1,))
    @test Matrix(rdm) ≈ [1/2 0; 0 1/2]
    reg = product_state([1, 0, 0])
    rdm = density_matrix(reg, (1, 2))
    @test Matrix(rdm) ≈ [0 0 0 0; 0 1 0 0; 0 0 0 0; 0 0 0 0]
end

@testset "von_neumann_entropy" begin
    reg = ghz_state(4)
    rho = density_matrix(reg)
    p = eigvals(statevec(reg) * statevec(reg)')
    p = max.(p, eps(Float64))
    @test von_neumann_entropy(rho) ≈ -sum(p .* log.(p)) rtol=1e-12

    rho = density_matrix(reg, 1:2)
    @test von_neumann_entropy(rho) ≈ log(2)
    @test von_neumann_entropy(rho) ≈ von_neumann_entropy(reg, 1:2)
end

@testset "mutual_information" begin 
    reg = product_state(bit"1001")
    @test mutual_information(reg, (1,2), (3,4)) ≈ 0. atol=1e-10
    rho = density_matrix(reg, 1:2)
    @test mutual_information(rho, (1,), (2,)) ≈ 0. atol=1e-10

    reg = ghz_state(4)
    @test mutual_information(reg, (1,2), (3,4)) ≈ 2log(2)
    @test_throws LocationConflictError mutual_information(reg, (1, 2), (1, 3))
    
    rho = density_matrix(reg, (1, 2))
    @test mutual_information(rho, (1,), (2,)) ≈ log(2)
end

@testset "relative and cross_entropy" begin 
    rho = rand_density_matrix(2)
    @test YaoArrayRegister.cross_entropy(rho, rho) ≈ von_neumann_entropy(rho) atol=1e-10

    rho1 = density_matrix(product_state(bit"0"))
    rho1.state[2,2] += eps(Float64)
    rho2 = density_matrix(ghz_state(2), (1,))
    @test YaoArrayRegister.relative_entropy(rho, rho) ≈ 0 atol=1e-10
    @test YaoArrayRegister.relative_entropy(rho1, rho2) ≈ log(2) atol=1e-10
    @test YaoArrayRegister.relative_entropy(rho2, rho1) ≈ -log(eps(Float64))/2 - von_neumann_entropy(rho2) atol=1e-10
end

@testset "density matrix" begin
    # copy, copyto! and similar
    reg = rand_state(3)
    r = density_matrix(reg)
    @test copy(r) == r
    @test density_matrix(r) == r


    r_manual = DensityMatrix(reg.state * reg.state')
    @test r_manual ≈ r

    r_similar = similar(r)
    @test r_similar isa DensityMatrix
    @test nqubits(r) == nqubits(r_similar)
    @test nlevel(r) == nlevel(r_similar)

    r_rand = rand_density_matrix(3)
    copyto!(r_rand, r)
    @test r_rand  ≈ r

    # pure state
    reg1 = rand_state(3)
    reg2 = rand_state(3)
    r1 = density_matrix(reg1, (2,1,3))
    r2 = density_matrix(reg2, (2,1,3))
    @test isapprox(fidelity(reg1, reg2), fidelity(r1, r2); atol=1e-10)
    
    # mixed state
    r1 = density_matrix(reg1, (2, 1))
    r2 = density_matrix(reg2, (2, 1))
    expected = abs(tr(sqrt(sqrt(r1.state) * r2.state * sqrt(r1.state))))
    @test expected ≈ fidelity(r1, r2) atol=1e-5

    # focused state is viewed as mixed state
    f1 = focus!(copy(reg1), (2, 1))
    f2 = focus!(copy(reg2), (2, 1))
    @test fidelity(r1, r2) ≈ fidelity(f1, f2) atol=1e-6

    # fidelity between focused and pure state
    f1 = rand_state(2)
    @test fidelity(density_matrix(f1, (1, 2)), r2) ≈ fidelity(f1, f2) atol=1e-6

    dm = rand_density_matrix(2)
    @test is_density_matrix(dm.state)
    @test eltype(dm.state) === ComplexF64

    dm = rand_density_matrix(ComplexF32, 2)
    @test is_density_matrix(dm.state)
    @test eltype(dm.state) === ComplexF32

    dm = rand_density_matrix(2; pure=true)
    @test tr(dm.state^2) ≈ 1
    @test eltype(dm.state) === ComplexF64

    dm = completely_mixed_state(2)
    @test dm.state == I(4) ./ 4
end

@testset "zero_state_like" begin
    rho = density_matrix(zero_state(3))
    @test zero_state_like(rho, 3) ≈ rho
end

@testset "partial trace" begin
    rho = density_matrix(product_state(bit"001"))
    @test partial_tr(rho, (1,2)) ≈ density_matrix(product_state(bit"0"))
    @test partial_tr(rho, (3,2)) ≈ density_matrix(product_state(bit"1"))
end

@testset "algebra" begin
    r = density_matrix(product_state(bit"001"))
    @test (r + r).state ≈ r.state .* 2
    @test (r - r).state ≈ zero(r.state)
    @test regscale!(copy(r), 3.0).state ≈ r.state .* 3
    @test regadd!(copy(r), r).state ≈ r.state .* 2
    @test regsub!(copy(r), r).state ≈ zero(r.state)
    @test -(r).state ≈ -r.state
end

@testset "printing" begin
    show(stdout, MIME"text/plain"(), rand_density_matrix(3))
end

@testset "join" begin
    r1 = density_matrix(arrayreg(bit"110"))
    r2 = density_matrix(arrayreg(bit"101"))
    r = join(r2, r1)
    @test measure(r) == [bit"101110"]
end

@testset "collapseto!" begin
    r = density_matrix(ghz_state(3))
    collapseto!(r, (1, 2) => (0, 0))
    res = measure(r; nshots=1000)
    @test all(==(bit"000"), res)
    @test isnormalized(r)
end

@testset "collapseto! with mixed states" begin
    rho = rand_density_matrix(8)
    collapseto!(rho, (5:8) => zeros(Int,4))  
    @test tr(rho.state) ≈ 1
end


@testset "measure on subset of qubits" begin
    r1 = density_matrix(arrayreg(bit"110"))
    r2 = density_matrix(arrayreg(bit"101"))
    r = join(r2, r1)
    @test measure(r, (1, 2)) == [bit"10"]
end

@testset "measure on density matrix, collapse" begin
    # AllLocs
    reg = ghz_state(3)
    rho = density_matrix(reg)
    res = measure!(rho)
    res2 = measure(rho; nshots=10)
    @test all(==(res), res2)

    # specific locs
    reg = ghz_state(3)
    rho = density_matrix(reg, (1, 2))
    res = measure!(rho, (1, 2))
    res2 = measure(rho, (1, 2); nshots=10)
    @test all(==(res), res2)
end


@testset "measure on density matrix, reset" begin
    # AllLocs
    reg = uniform_state(3)
    rho = density_matrix(reg)
    res = measure!(ResetTo(bit"110"), rho)
    res2 = measure(rho; nshots=10)
    @test all(==(bit"110"), res2)

    # specific locs
    reg = uniform_state(5)
    rho = density_matrix(reg, (1, 2, 3))
    res = measure!(ResetTo(bit"10"), rho, (1, 2))
    res2 = measure(rho, (1, 2); nshots=10)
    @test all(==(bit"10"), res2)
end

@testset "measure on density matrix, remove" begin
    # AllLocs
    reg = uniform_state(3)
    rho = density_matrix(reg, (1, 2))
    res = measure!(RemoveMeasured(), rho)
    @test nqubits(rho) == 0
    @test isnormalized(rho)

    # specific locs
    reg = uniform_state(5)
    rho = density_matrix(reg, (1, 2, 3))
    res = measure!(RemoveMeasured(), rho, (1, 2))
    @test nqubits(rho) == 1
    @test isnormalized(rho)
end

using PkgBenchmark

current = BenchmarkConfig(id = "transpose_storage", juliacmd = `julia -O3`)
baseline = BenchmarkConfig(id = "master", juliacmd = `julia -O3`)
results = judge("YaoArrayRegister", current, baseline)
export_markdown("report.md", results)

using Test, YaoArrayRegister, YaoAPI

@testset "select" begin
    reg = product_state(4, 6; nbatch = 2)
    # println(focus!(reg, [1,3]))
    r1 = select!(focus!(copy(reg), [2, 3]), 0b11) |> relax!(to_nactive = 2)
    r2 = select(focus!(copy(reg), [2, 3]), 0b11) |> relax!(to_nactive = 2)
    r3 = copy(reg) |> focus!(2, 3) |> select!(0b11) |> relax!(to_nactive = 2)

    @test r1' * r1 ≈ ones(2)
    @test r1 ≈ r2
    @test r3 ≈ r2
end

@testset "measure and resetto/remove" begin
    reg = rand_state(4)
    res = measure!(YaoAPI.ResetTo(0), reg, (4,))
    @test isnormalized(reg)
    result = measure(reg; nshots = 10)
    @test all(result .< 8)
    @test ndims(res) == 0

    reg = rand_state(6) |> focus!(1, 4, 3)
    reg0 = copy(reg)
    res = measure!(YaoAPI.RemoveMeasured(), reg)
    @test nqubits(reg) == 3
    select(reg0, res)
    @test select(reg0, res) |> normalize! ≈ reg
    @test ndims(res) == 0

    r = rand_state(10)
    r1 = copy(r) |> focus!(1, 4, 3)
    res = measure!(YaoAPI.RemoveMeasured(), r, (1, 4, 3))
    r2 = select(r1, res)
    r2 = relax!(r2, (); to_nactive = nqubits(r2))
    @test normalize!(r2) ≈ r
    @test ndims(res) == 0

    reg = rand_state(6, nbatch = 5) |> focus!((1:5)...)
    res = measure!(YaoAPI.ResetTo(0), reg, 1)
    @test nactive(reg) == 5
    @test ndims(res) == 1
end

@testset "fix measure kwargs error" begin
    r = rand_state(10)
    @test length(measure(r; nshots = 10)) == 10
    @test_throws MethodError measure!(r; nshots = 10)
    @test_throws MethodError measure!(YaoAPI.RemoveMeasured(), r; nshots = 10)
end

@testset "fix measure output type error" begin
    res = measure(rand_state(1; nbatch = 10))
    @test res isa Matrix{<:BitStr{1}}
end

@testset "fix measure kwargs error" begin
    r = rand_state(10)
    @test length(measure(r; nshots = 10)) == 10
    @test_throws MethodError measure!(r; nshots = 10)
    @test_throws MethodError measure!(YaoAPI.RemoveMeasured(), r; nshots = 10)
end

@testset "measure qudits" begin
    @test measure(product_state(dit"121;3")) == [dit"121;3"]
end

@testset "measure density matrix" begin
    reg = product_state(bit"011101")
    @test measure(density_matrix(reg); nshots=3) == fill(bit"011101", 3)
end

using Test, YaoArrayRegister

@testset "errors" begin
    @test_throws ErrorException @assert_locs_inbounds 4 (1, 2, 3, 4, 5)
    @test_throws ErrorException @assert_locs_inbounds 4 collect(1:5)

    @test_throws LocationConflictError @assert_locs_safe 4 (1, 2, 2, 1)
    @test_throws LocationConflictError @assert_locs_safe 4 [1, 3, 2, 2]

    @test_throws ErrorException @assert_locs_inbounds 4 (1, 2, 3, 4, 5)
    @test_throws ErrorException @assert_locs_inbounds 4 collect(1:5)

    @test_throws LocationConflictError @assert_locs_safe 4 (1, 2, 2, 1)
    @test_throws LocationConflictError @assert_locs_safe 4 [1, 3, 2, 2]
end

YaoAPI.DensityMatrix{D}(state::AbstractMatrix{T}) where {T,D} = DensityMatrix{D,T,typeof(state)}(state)
YaoAPI.DensityMatrix(state::AbstractMatrix{T}; nlevel=2) where T = DensityMatrix{nlevel}(state)

"""
    state(ρ::DensityMatrix) -> Matrix

Return the raw state of density matrix `ρ`.
"""
state(ρ::DensityMatrix) = ρ.state
Base.copy(ρ::DensityMatrix{D}) where D = DensityMatrix{D}(copy(ρ.state))
Base.similar(ρ::DensityMatrix{D}) where {D} = DensityMatrix{D}(similar(ρ.state))
Base.:(==)(ρ::DensityMatrix, σ::DensityMatrix) = nlevel(ρ) == nlevel(σ) && ρ.state == σ.state
Base.isapprox(ρ::DensityMatrix, σ::DensityMatrix; kwargs...) = nlevel(ρ) == nlevel(σ) && isapprox(ρ.state, σ.state; kwargs...)

function Base.copyto!(dst::DensityMatrix{D}, src::DensityMatrix{D}) where D
    copyto!(dst.state, src.state)
    return dst
end

YaoAPI.nqubits(ρ::DensityMatrix) = nqudits(ρ)
YaoAPI.nqudits(ρ::DensityMatrix{D}) where {D} = logdi(size(state(ρ), 1), D)
YaoAPI.nactive(ρ::DensityMatrix) = nqudits(ρ)
nbatch(::DensityMatrix) = NoBatch()
chstate(::DensityMatrix{D}, state) where D = DensityMatrix{D}(state)

"""
    rand_density_matrix([T=ComplexF64], n::Int; nlevel::Int=2, pure::Bool=false)

Generate a random density matrix by partial tracing half of the pure state.

!!! note

    The generated density matrix is not strict hermitian due to rounding error.
    If you need to check hermicity, do not use `ishermitian` consider using
    `isapprox(dm.state, dm.state')` or explicit mark it as `Hermitian`.
"""
function rand_density_matrix(n::Int; nlevel::Int=2, pure::Bool=false)
    return rand_density_matrix(ComplexF64, n; nlevel, pure)
end

function rand_density_matrix(::Type{T}, n::Int; nlevel::Int=2, pure::Bool=false) where T
    return pure ? density_matrix(rand_state(T, n; nlevel)) :
                  density_matrix(rand_state(T, 2n; nlevel), n+1:2n)
end

"""
    completely_mixed_state([T=ComplexF64], n::Int; nlevel::Int=2)

Generate the completely mixed state with density matrix `I(n) ./ nlevel^n`.
"""
function completely_mixed_state(::Type{T}, n::Int; nlevel::Int=2) where T
    return DensityMatrix{nlevel}(diagm(0 => fill(one(T) / nlevel^n, nlevel^n)))
end

completely_mixed_state(n::Int; nlevel::Int=2) = completely_mixed_state(ComplexF64, n; nlevel)

# Move this to YaoAPI and dispatch on `AbstractRegister{D}`?
# Could then remove from YaoArrayRegister/src/register.jl and here
qubit_type(::DensityMatrix{2}) = "qubits"
qubit_type(::DensityMatrix) = "qudits"

function Base.show(io::IO, dm::DensityMatrix{D,T,MT}) where {D,T,MT}
    print(io, "DensityMatrix{$D, $T, $(nameof(MT))...}")
    print(io, "\n    active $(qubit_type(dm)): ", nactive(dm), "/", nqudits(dm))
    print(io, "\n    nlevel: ", nlevel(dm))
end

function YaoAPI.density_matrix(reg::ArrayReg, qubits)
    freg = focus!(copy(reg), qubits)
    return density_matrix(freg)
end
function YaoAPI.density_matrix(dm::DensityMatrix, locs)
    n = nqudits(dm)
    @assert_locs_safe n (locs...,)
    return partial_tr(dm, setdiff(1:n, locs))
end
YaoAPI.density_matrix(reg::ArrayReg{D}) where D = DensityMatrix{D}(reg.state * reg.state')
YaoAPI.density_matrix(rho::DensityMatrix) = copy(rho)

YaoAPI.tracedist(dm1::DensityMatrix{D}, dm2::DensityMatrix{D}) where {D} = trace_norm(dm1.state .- dm2.state) / 2.0

"""
    is_density_matrix(dm::AbstractMatrix; kw...)

Test if given matrix is a density matrix. The keyword is the same as `isapprox`.
See also `isapprox`.
"""
function is_density_matrix(dm::AbstractMatrix; kw...)
    return isapprox(tr(dm), 1.0; kw...) &&
        isapprox(dm, dm';kw...) &&
        isposdef(Hermitian(dm))
end

# TODO: use batch_broadcast in the future
"""
    probs(ρ) -> Vector

Returns the probability distribution from a density matrix `ρ`.
"""
YaoAPI.probs(m::DensityMatrix) = real.(diag(m.state))

function YaoAPI.fidelity(m::DensityMatrix, n::DensityMatrix)
    return density_matrix_fidelity(m.state, n.state)
end

YaoAPI.fidelity2(m::DensityMatrix, n::DensityMatrix) = YaoAPI.fidelity(m, n)^2

function YaoAPI.purify(r::DensityMatrix{D}; num_env::Int = nactive(r)) where {D}
    Ne = D ^ num_env
    Ns = size(r.state, 1)
    R, U = eigen(r.state)
    state = view(U, :, Ns-Ne+1:Ns) .* sqrt.(abs.(view(R, Ns-Ne+1:Ns)'))
    return ArrayReg{D}(state)
end

# obtaining matrix from Yao.DensityMatrix
LinearAlgebra.Matrix(d::DensityMatrix) = d.state

function zero_state_like(dm::DensityMatrix{D,T}, n::Int) where {D,T}
    state = similar(dm.state, D^n, D^n)   # NOTE: does not preserve adjoint
    fill!(state,zero(T))
    state[1:1,1:1] .= Ref(one(T))  # broadcast to make it GPU compatible.
    return DensityMatrix{D}(state)
end

"""
    von_neumann_entropy(rho) -> Real

Return the von-Neumann entropy for the input density matrix:

```math
-{\\rm Tr}(\\rho\\ln\\rho)
```
"""
von_neumann_entropy(dm::DensityMatrix) = von_neumann_entropy(Matrix(dm))
function von_neumann_entropy(dm::AbstractMatrix)
    p = max.(eigvals(dm), eps(real(eltype(dm))))
    return von_neumann_entropy(p)
end
von_neumann_entropy(v::AbstractVector) = -sum(x->x*log(x), v)

function mutual_information(dm::DensityMatrix, part1, part2)
    n = nqudits(dm)
    @assert_locs_safe n collect(Iterators.flatten((part1, part2)))
    return von_neumann_entropy(density_matrix(dm, part1)) + 
        von_neumann_entropy(density_matrix(dm, part2)) - 
        von_neumann_entropy(length(part1) + length(part2) == n ? dm : density_matrix(dm, part1 ∪ part2))
end

"""
    relative_entropy(rho1, rho2) -> Real

The relative entropy between two density matrices ``\\rho_1`` and ``\\rho_2`` is defined as:
```math
S(\\rho_1||\\rho_2) = \\rho_1\\ln\\rho_1 - \\rho_1\\ln\\rho_2,
```
which is equivalent to subtracting the cross entropy ``S(\\rho_1, \\rho_2)``, by the entropy of ``\\rho_1``.
"""
function relative_entropy(dm1::DensityMatrix, dm2::DensityMatrix)
    - von_neumann_entropy(dm1) + cross_entropy(dm1, dm2)
end

"""
    cross_entropy(rho1, rho2) -> Real

The cross entropy between two density matrices ``ρ_1`` and ``ρ_2`` is defined as:
```math
S(ρ_1, ρ_2) = - ρ_1\\ln ρ_2.
```
"""
function cross_entropy(dm1::DensityMatrix, dm2::DensityMatrix)
    - real(sum(transpose(dm1.state) .* log(dm2.state)))
end

function YaoAPI.partial_tr(dm::DensityMatrix{D,T}, locs) where {D,T}
    locs = Tuple(locs)
    nbits = nqudits(dm)
    @assert_locs_safe nbits (locs...,)
    m = nbits-length(locs)
    strides = ntuple(i->D^(i-1), nbits)
    out_strides = ntuple(i->D^(i-1), m)
    remainlocs = (setdiff(1:nbits, locs)...,)
    remain_strides = map(i->strides[i], remainlocs)
    trace_strides = ntuple(i->strides[locs[i]], length(locs))
    state = similar(dm.state, D^m, D^m)   # NOTE: does not preserve adjoint
    fill!(state, zero(T))
    partial_tr!(Val{D}(), state, dm.state, trace_strides, out_strides, remain_strides)
    return DensityMatrix{D}(state)
end

@generated function partial_tr!(::Val{D}, out::AbstractMatrix, dm::AbstractMatrix, trace_strides::NTuple{K,Int}, out_strides::NTuple{M,Int}, remain_strides::NTuple{M,Int}) where {D,K,M}
    quote
        sumc = length(remain_strides) == 0 ? 1 : 1 - sum(remain_strides)
        suma = length(out_strides) == 0 ? 1 : 1 - sum(out_strides)
        Base.Cartesian.@nloops($M, i, d->1:$D,
                d->(@inbounds sumc += i_d*remain_strides[d]; @inbounds suma += i_d*out_strides[d]), # PRE
                d->(@inbounds sumc -= i_d*remain_strides[d]; @inbounds suma -= i_d*out_strides[d]), # POST
                begin # BODY
                    sumd = length(remain_strides) == 0 ? 1 : 1 - sum(remain_strides)
                    sumb = length(out_strides) == 0 ? 1 : 1 - sum(out_strides)
                    Base.Cartesian.@nloops($M, j, d->1:$D,
                        d->(@inbounds sumd += j_d*remain_strides[d]; @inbounds sumb += j_d*out_strides[d]), # PRE
                        d->(@inbounds sumd -= j_d*remain_strides[d]; @inbounds sumb -= j_d*out_strides[d]), # POST
                        begin
                            sume = length(trace_strides) == 0 ? 1 : 1 - sum(trace_strides)
                            Base.Cartesian.@nloops($K, k, d->1:$D,
                                d->(@inbounds sume += k_d*trace_strides[d]), # PRE
                                d->(@inbounds sume -= k_d*trace_strides[d]), # POST
                                @inbounds out[suma, sumb] += dm[sumc+sume-1, sumd+sume-1]
                                )
                        end)
                end)

    end
end

"""
$(TYPEDSIGNATURES)
"""
function Base.join(r0::DensityMatrix{D}, rs::DensityMatrix{D}...) where {D}
    length(rs) == 0 && return r0
    st = kron(state(r0), state.(rs)...)
    return DensityMatrix{D}(st)
end

function YaoAPI.collapseto!(rho::DensityMatrix, locsval::Pair)
    locs = locsval.first isa AllLocs ? (1:nqudits(rho)) : locsval.first
    ic = itercontrol(nqudits(rho), collect(locs), locsval.second) .+ 1
    st = rho.state[ic, ic]
    
    trace_norm = tr(st)  
    if real(trace_norm) <= 1e-10
        @warn "Collapse resulted in a near-zero probability state. Normalization may be inaccurate."
    end
    st ./= trace_norm  
    fill!(rho.state, 0)
    rho.state[ic, ic] .= st
    return rho
end

using LinearAlgebra, StaticArrays, LuxurySparse, SparseArrays
using Test
import YaoArrayRegister: swaprows!, swapcols!, mulrow!, mulcol!, u1rows!, unrows!,
    batch_normalize, hilbertkron, batch_normalize!, batched_kron, rot_mat, invorder, reorder, logdi

@testset "swaprows! & mulrow!" begin
    a = [1, 2, 3, 5.0]
    A = Float64.(reshape(1:8, 4, 2))
    @test swaprows!(copy(a), 2, 4) ≈ [1, 5, 3, 2]
    @test swaprows!(copy(a), 2, 4, 0.1, 0.2) ≈ [1, 1, 3, 0.2]
    @test swapcols!(copy(a), 2, 4) ≈ [1, 5, 3, 2]
    @test swapcols!(copy(a), 2, 4, 0.1, 0.2) ≈ [1, 1, 3, 0.2]
    @test swaprows!(copy(A), 2, 4) ≈ [1 5; 4 8; 3 7; 2 6]
    @test swaprows!(copy(A), 2, 4, 0.1, 0.2) ≈ [1 5; 0.8 1.6; 3 7; 0.2 0.6]
    @test swapcols!(copy(A), 2, 1) ≈ [5 1; 6 2; 7 3; 8 4]
    @test swapcols!(copy(A), 2, 1, 0.1, 0.2) ≈ [0.5 0.2; 0.6 0.4; 0.7 0.6; 0.8 0.8]

    @test mulrow!(copy(a), 2, 0.1) ≈ [1, 0.2, 3, 5]
    @test mulcol!(copy(a), 2, 0.1) ≈ [1, 0.2, 3, 5]
    @test mulrow!(copy(A), 2, 0.1) ≈ [1 5; 0.2 0.6; 3 7; 4 8]
    @test mulcol!(copy(A), 2, 0.1) ≈ [1 0.5; 2 0.6; 3 0.7; 4 0.8]
end

@testset "u1rows! & unrows!" begin
    for v in [randn(ComplexF64, 1 << 6), randn(ComplexF64, 1 << 6, 3)]
        u1 = randn(ComplexF64, 2, 2)
        su1 = SMatrix{2,2}(u1)
        inds1 = [1, 3]
        sinds1 = SVector{2}(inds1)
        @test 0 == @allocated unrows!(v, sinds1, su1)

        unrows!(v, sinds1, su1)
        @test u1rows!(copy(v), inds1..., u1[1], u1[3], u1[2], u1[4]) ≈
              unrows!(copy(v), inds1, u1)
        @test unrows!(copy(v), inds1, u1) ≈ unrows!(copy(v), sinds1, su1)
    end
end


@testset "dense unrows!" begin
    v = randn(ComplexF64, 1 << 6, 2)
    inds = [1, 3, 8, 2]
    A = rand(ComplexF64, 4, 4)
    sinds = SVector{4}(inds)
    sA = SMatrix{4,4}(A)
    unrows!(v, sinds, sA)
    @test 0 == @allocated unrows!(v, sinds, sA)
    out = zeros(ComplexF64, 4, 4)
    @test unrows!(copy(v), sinds, sA)[:, 1] ≈ unrows!(copy(v[:, 1]), inds, A)
end

@testset "diagonal unrows!" begin
    v = randn(ComplexF64, 1 << 6)
    dg = ComplexF64[1 0; 0 -1] |> staticize
    inds = SVector{2}([1, 3])
    unrows!(v, inds, dg)
    # NOTE: some machines have a small allocation
    @test 32 >= @allocated unrows!(v, inds, dg)
    @test unrows!(copy(v), inds, dg) ≈ unrows!(copy(v), [1, 3], dg)
    @test unrows!(copy(v), inds, IMatrix(4)) == v
end

@testset "permmatrix unrows!" begin
    N, M = 6, 2
    v = randn(ComplexF64, 1 << N)
    pm = pmrand(ComplexF64, 1 << M)
    inds = [1, 3, 8, 2]
    sinds = SVector{1 << M}(inds)
    spm = pm |> staticize
    unrows!(v, inds, spm)
    @test unrows!(copy(v), sinds, spm) ≈ unrows!(copy(v), inds, pm |> Matrix)
end

@testset "csc unrows!" begin
    v = randn(ComplexF64, 1 << 6)
    inds = [1, 3, 8, 2]
    A = sprand(ComplexF64, 4, 4, 0.5)
    work = zeros(ComplexF64, 4)
    sinds = SVector{4}(inds)
    sA = A |> staticize
    unrows!(v, sinds, sA, work)
    # TODO: this use views?
    # @test 0 == @allocated unrows!(v, sinds, sA, work)
    @test unrows!(copy(v), sinds, sA, work) ≈ unrows!(copy(v), inds, A |> Matrix)
end

@testset "batch normalize" begin
    s = rand(3, 4)
    batch_normalize!(s, 1)
    for i = 1:4
        @test sum(s[:, i]) ≈ 1
    end

    s = rand(3, 4)
    ss = batch_normalize(s, 1)
    for i = 1:4
        @test sum(s[:, i]) != 1
        @test sum(ss[:, i]) ≈ 1
    end
end

@testset "hilbertkron" begin
    A, B, C, D = [randn(2, 2) for i = 1:4]
    II = IMatrix(2)
    ⊗ = kron
    @test hilbertkron(4, [A, B], [3, 1]) ≈ II ⊗ A ⊗ II ⊗ B
    @test hilbertkron(4, [A ⊗ B, C], [3, 1]) ≈ A ⊗ B ⊗ II ⊗ C
    @test hilbertkron(4, [A ⊗ B], [1]) ≈ II ⊗ II ⊗ A ⊗ B
    @test hilbertkron(4, [A ⊗ B, C ⊗ D], [1, 3]) ≈ C ⊗ D ⊗ A ⊗ B

    U = randn(2, 2)
    U2 = randn(4, 4)
    m = U2 ⊗ II ⊗ U ⊗ II
    @test m == hilbertkron(5, [U, U2], [2, 4])
end

@testset "batched kron" begin
    A, B, C =
        rand(ComplexF64, 4, 4, 3), rand(ComplexF64, 4, 4, 3), rand(ComplexF64, 4, 4, 3)
    D = batched_kron(A, B, C)

    tD = zeros(ComplexF64, 64, 64, 3)
    for k = 1:3
        tD[:, :, k] = kron(A[:, :, k], B[:, :, k], C[:, :, k])
    end

    @test tD ≈ D

    B2 = reshape(transpose(reshape(permutedims(B, (3, 1, 2)), 3, 16)), 4, 4, 3)
    @test B2 isa Base.ReshapedArray
    @test Array(B2) ≈ B
    D2 = batched_kron(A, B2, C)
    @test tD ≈ D2
end

@testset "rotmat" begin
    theta = 0.5
    @test rot_mat(ComplexF64, Const.X, theta) ≈ ComplexF64[
        cos(theta / 2) -im*sin(theta / 2)
        -im*sin(theta / 2) cos(theta / 2)
    ]
    @test rot_mat(ComplexF64, Const.X, theta) |> eltype == ComplexF64
    @test rot_mat(ComplexF32, Const.X, theta) |> eltype == ComplexF32
end

using LuxurySparse: pmrand
@testset "reorder" begin
    ⊗ = kron
    PA = pmrand(2)
    PB = pmrand(2)
    PC = pmrand(2)
    @test reorder(PC ⊗ PB ⊗ PA, [3, 1, 2]) ≈ PB ⊗ PA ⊗ PC
    @test invorder(PC ⊗ PB ⊗ PA) ≈ PA ⊗ PB ⊗ PC
end

@testset "logdi" begin
    @test logdi(9, 3) == 2
    @test_throws ArgumentError logdi(9, 5)
end

@testset "matchtype" begin
    @test YaoArrayRegister.matchtype(ComplexF64, randn(2,2)) isa Array{ComplexF64}
    @test YaoArrayRegister.matchtype(ComplexF64, randn(ComplexF64, 2,2)) isa Array{ComplexF64}
end

# Benchmark Test for YaoArrayRegister
# NOTE: we only test the standard interface here:
# 1. locations are all tuples
#
# forwarded bindings should be tested in YaoBlocks via blocks.

using PkgBenchmark, BenchmarkTools
using YaoArrayRegister, BitBasis, Random, YaoAPI, StaticArrays, LuxurySparse
using LinearAlgebra, SparseArrays

bench(n, U, loc::Tuple) =
    @benchmarkable instruct!(st, $U, $loc) setup = (st = statevec(rand_state($n)))
bench(n, U, loc::Tuple, control_locs::Tuple, control_bits::Tuple) =
    @benchmarkable instruct!(st, $U, $loc, $control_locs, $control_bits) setup =
        (st = statevec(rand_state($n)))
bench(n, B::Int, U, loc::Tuple) = @benchmarkable instruct!(st, $U, $loc) setup =
    (st = statevec(rand_state($n, nbatch = $B)))
bench(n, B::Int, U, loc::Tuple, control_locs::Tuple, control_bits::Tuple) =
    @benchmarkable instruct!(st, $U, $loc, $control_locs, $control_bits) setup =
        (st = statevec(rand_state($n, nbatch = $B)))


const SUITE = BenchmarkGroup()
SUITE["specialized"] = BenchmarkGroup()

@info "generating benchmark for specialized operators for single qubits"
# Specialized Gate Instruction
SUITE["specialized"]["single qubit"] = BenchmarkGroup()
## single qubit benchmark
for U in YaoArrayRegister.SPECIALIZATION_LIST, n = 1:4:25
    SUITE["specialized"]["single qubit"][string(U), n] = bench(n, Val(U), (1,))
end

SUITE["specialized"]["single control"] = BenchmarkGroup()
for U in YaoArrayRegister.SPECIALIZATION_LIST, n = 4:4:25
    SUITE["specialized"]["single control"][string(U), n, (2,), (1,)] =
        bench(n, Val(U), (1,), (2,), (1,))
end

SUITE["specialized"]["multi control"] = BenchmarkGroup()

for U in YaoArrayRegister.SPECIALIZATION_LIST, n = 4:4:25
    control_locs = Tuple(2:n)
    control_bits = ntuple(x -> 1, n - 1)
    SUITE["specialized"]["multi control"][string(U), n, 2:n, control_locs] =
        bench(n, Val(U), (1,), control_locs, control_bits)
end

SUITE["specialized"]["multi qubit"] = BenchmarkGroup()
const location_sparsity = 0.4
@info "generating benchmark for specialized operators for multi qubits"
## multi qubit benchmark
for U in YaoArrayRegister.SPECIALIZATION_LIST, n = 4:4:25
    perms = randperm(n)[1:ceil(Int, location_sparsity * n)]
    SUITE["specialized"]["multi qubit"][string(U), n] = bench(n, Val(U), Tuple(perms))
end

SUITE["specialized"]["multi qubit multi control"] = BenchmarkGroup()
SUITE["specialized"]["single qubit multi control"] = BenchmarkGroup()

const control_rate = 0.3
for U in YaoArrayRegister.SPECIALIZATION_LIST, n = 4:4:25
    num_controls = ceil(Int, n * control_rate)
    perms = randperm(n)
    control_locs = Tuple(perms[1:num_controls])
    control_bits = ntuple(x -> rand(0:1), num_controls)
    perms = perms[num_controls+1:num_controls+round(Int, location_sparsity * n)]

    SUITE["specialized"]["multi qubit multi control"][string(U), n, num_controls] =
        bench(n, Val(U), Tuple(perms), control_locs, control_bits)
    SUITE["specialized"]["single qubit multi control"][string(U), n, num_controls] =
        bench(n, Val(U), (perms[1],), control_locs, control_bits)
end

for n = 4:4:25
    SUITE["specialized"]["multi qubit"]["SWAP", n] = bench(n, Val(:SWAP), (1, 2))
    SUITE["specialized"]["multi qubit"]["SWAP", "random", n] =
        bench(n, Val(:SWAP), Tuple(randperm(n)[1:2]))
end

# General Instructions (matrices based)
SUITE["matrices"] = BenchmarkGroup()
SUITE["matrices"]["contiguous"] = BenchmarkGroup()
SUITE["matrices"]["contiguous"]["ordered"] = BenchmarkGroup()
SUITE["matrices"]["contiguous"]["random"] = BenchmarkGroup()

SUITE["matrices"]["in-contiguous"] = BenchmarkGroup()
SUITE["matrices"]["in-contiguous"]["ordered"] = BenchmarkGroup()
SUITE["matrices"]["in-contiguous"]["random"] = BenchmarkGroup()

SUITE["matrices"]["single qubit"] = BenchmarkGroup()
SUITE["matrices"]["single qubit"]["ordered"] = BenchmarkGroup()
SUITE["matrices"]["single qubit"]["random"] = BenchmarkGroup()


## General Matrix Instruction
function matrices(::Type{T}, N) where {T}
    list = Any[
        rand_unitary(T, N), # dense matrices
        # SparseMatrixCSC
        sprand_hermitian(T, N, 0.1),
        # PermMatrix
        pmrand(T, N),
        Diagonal(rand(T, N)),
    ]
    if N < 100
        # StaticArrays
        push!(list, @SArray(rand(T, N, N)))
        push!(list, @MArray(rand(T, N, N)))
    end
    return list
end

# default test type is ComplexF64
matrices(N) = matrices(ComplexF64, N)

@info "generating benchmark for contiguous matrices locs"
### contiguous
for n = 1:2:10, T in [ComplexF64], U in matrices(T, 1 << n)
    # contiguous ordered address
    SUITE["matrices"]["contiguous"]["ordered"][n, string(T), string(typeof(U))] =
        bench(n, U, Tuple(1:n))
    # contiguous random address
    SUITE["matrices"]["contiguous"]["random"][n, string(T), string(typeof(U))] =
        bench(n, U, Tuple(randperm(n)))
end

@info "generating benchmark for in-contiguous matrices locs"
### in-contiguous
for m = 1:3, T in [ComplexF64], U in matrices(T, 1 << m)
    n = 10
    N = 1 << n
    # in-contiguous ordered address
    SUITE["matrices"]["in-contiguous"]["ordered"][m, string(T), string(typeof(U))] =
        bench(n, U, Tuple(sort(randperm(n)[1:m])))
    # in-contiguous random address
    SUITE["matrices"]["in-contiguous"]["random"][m, string(T), string(typeof(U))] =
        bench(n, U, Tuple(randperm(n)[1:m]))
end

@info "generating benchmark for single qubit matrices"
### single qubit
for T in [ComplexF64], U in matrices(T, 2), n = 1:4:25
    SUITE["matrices"]["single qubit"]["ordered"][string(T), string(typeof(U)), n] =
        bench(n, U, (rand(1:n),))
    SUITE["matrices"]["single qubit"]["random"][string(T), string(typeof(U)), n] =
        bench(n, U, (rand(1:n),))
end

SUITE["matrices"]["controlled"] = BenchmarkGroup()
SUITE["matrices"]["controlled"]["ordered"] = BenchmarkGroup()
SUITE["matrices"]["controlled"]["random"] = BenchmarkGroup()

test_bench(n, U, loc, control_locs, control_bits) =
    instruct!(statevec(rand_state(n)), U, loc, control_locs, control_bits)
for T in [ComplexF64], n = 1:2:10, m = 3:2:6, U in matrices(T, 1 << n)
    SUITE["matrices"]["controlled"]["ordered"][n, m, string(T), string(typeof(U))] =
        bench(n + m, U, Tuple(1:n), Tuple(n+1:n+m), ntuple(x -> 1, m))

    perms = randperm(n + m)
    SUITE["matrices"]["controlled"]["random"][n, m, string(T), string(typeof(U))] =
        bench(n + m, U, Tuple(perms[1:n]), Tuple(perms[n+1:n+m]), ntuple(x -> 1, m))
end


# batched
SUITE["batched specialized"] = BenchmarkGroup()

@info "generating benchmark for batched specialized operators for single qubits"
# Specialized Gate Instruction
SUITE["batched specialized"]["single qubit"] = BenchmarkGroup()
## single qubit benchmark
for U in YaoArrayRegister.SPECIALIZATION_LIST, n = 5:4:15, B = 10:20:60
    SUITE["batched specialized"]["single qubit"][string(U), n, B] =
        bench(n, B, Val(U), (1,))
end

SUITE["batched specialized"]["single control"] = BenchmarkGroup()
for U in YaoArrayRegister.SPECIALIZATION_LIST, n = 5:4:15, B = 10:20:60
    SUITE["batched specialized"]["single control"][string(U), n, B, (2,), (1,)] =
        bench(n, B, Val(U), (1,), (2,), (1,))
end

SUITE["batched specialized"]["multi control"] = BenchmarkGroup()

for U in YaoArrayRegister.SPECIALIZATION_LIST, n = 5:4:15, B = 10:20:60
    control_locs = Tuple(2:n)
    control_bits = ntuple(x -> 1, n - 1)
    SUITE["batched specialized"]["multi control"][string(U), n, B, 2:n, control_locs] =
        bench(n, B, Val(U), (1,), control_locs, control_bits)
end

SUITE["batched specialized"]["multi qubit"] = BenchmarkGroup()
const location_sparsity = 0.4
@info "generating benchmark for specialized operators for multi qubits"
## multi qubit benchmark
for U in YaoArrayRegister.SPECIALIZATION_LIST, n = 5:4:15, B = 10:20:60
    perms = randperm(n)[1:ceil(Int, location_sparsity * n)]
    SUITE["batched specialized"]["multi qubit"][string(U), n, B] =
        bench(n, B, Val(U), Tuple(perms))
end

SUITE["batched specialized"]["multi qubit multi control"] = BenchmarkGroup()
SUITE["batched specialized"]["single qubit multi control"] = BenchmarkGroup()

const control_rate = 0.3
for U in YaoArrayRegister.SPECIALIZATION_LIST, n = 5:4:15, B = 10:20:60
    num_controls = ceil(Int, n * control_rate)
    perms = randperm(n)
    control_locs = Tuple(perms[1:num_controls])
    control_bits = ntuple(x -> rand(0:1), num_controls)
    perms = perms[num_controls+1:num_controls+round(Int, location_sparsity * n)]

    SUITE["batched specialized"]["multi qubit multi control"][
        string(U),
        n,
        B,
        num_controls,
    ] = bench(n, B, Val(U), Tuple(perms), control_locs, control_bits)
    SUITE["batched specialized"]["single qubit multi control"][
        string(U),
        n,
        B,
        num_controls,
    ] = bench(n, B, Val(U), (perms[1],), control_locs, control_bits)
end

for n = 5:4:15, B = 10:20:60
    SUITE["batched specialized"]["multi qubit"]["SWAP", n, B] =
        bench(n, B, Val(:SWAP), (1, 2))
    SUITE["batched specialized"]["multi qubit"]["SWAP", "random", n, B] =
        bench(n, B, Val(:SWAP), Tuple(randperm(n)[1:2]))
end

# General Instructions (matrices based)
SUITE["batched matrices"] = BenchmarkGroup()
SUITE["batched matrices"]["contiguous"] = BenchmarkGroup()
SUITE["batched matrices"]["contiguous"]["ordered"] = BenchmarkGroup()
SUITE["batched matrices"]["contiguous"]["random"] = BenchmarkGroup()

SUITE["batched matrices"]["in-contiguous"] = BenchmarkGroup()
SUITE["batched matrices"]["in-contiguous"]["ordered"] = BenchmarkGroup()
SUITE["batched matrices"]["in-contiguous"]["random"] = BenchmarkGroup()

SUITE["batched matrices"]["single qubit"] = BenchmarkGroup()
SUITE["batched matrices"]["single qubit"]["ordered"] = BenchmarkGroup()
SUITE["batched matrices"]["single qubit"]["random"] = BenchmarkGroup()


## General Matrix Instruction
function matrices(::Type{T}, N) where {T}
    list = Any[
        rand_unitary(T, N), # dense matrices
        # SparseMatrixCSC
        sprand_hermitian(T, N, 0.1),
        # PermMatrix
        pmrand(T, N),
        Diagonal(rand(T, N)),
    ]
    if N < 100
        # StaticArrays
        push!(list, @SArray(rand(T, N, N)))
        push!(list, @MArray(rand(T, N, N)))
    end
    return list
end

# default test type is ComplexF64
matrices(N) = matrices(ComplexF64, N)

@info "generating benchmark for batched contiguous matrices locs"
### contiguous
for n = 1:2:5, T in [ComplexF64], U in matrices(T, 1 << n), B = 10:20:60
    # contiguous ordered address
    SUITE["batched matrices"]["contiguous"]["ordered"][n, B, string(T), string(typeof(U))] =
        bench(n, B, U, Tuple(1:n))
    # contiguous random address
    SUITE["batched matrices"]["contiguous"]["random"][n, B, string(T), string(typeof(U))] =
        bench(n, B, U, Tuple(randperm(n)))
end

@info "generating benchmark for in-contiguous matrices locs"
### in-contiguous
for m = 1:3, T in [ComplexF64], U in matrices(T, 1 << m), B = 10:20:60
    n = 10
    N = 1 << n
    # in-contiguous ordered address
    SUITE["batched matrices"]["in-contiguous"]["ordered"][
        m,
        B,
        string(T),
        string(typeof(U)),
    ] = bench(n, B, U, Tuple(sort(randperm(n)[1:m])))
    # in-contiguous random address
    SUITE["batched matrices"]["in-contiguous"]["random"][
        m,
        B,
        string(T),
        string(typeof(U)),
    ] = bench(n, B, U, Tuple(randperm(n)[1:m]))
end

@info "generating benchmark for single qubit matrices"
### single qubit
for T in [ComplexF64], U in matrices(T, 2), n = 1:4:25, B = 10:20:60
    SUITE["batched matrices"]["single qubit"]["ordered"][
        string(T),
        B,
        string(typeof(U)),
        n,
    ] = bench(n, B, U, (rand(1:n),))
    SUITE["batched matrices"]["single qubit"]["random"][
        string(T),
        B,
        string(typeof(U)),
        n,
    ] = bench(n, B, U, (rand(1:n),))
end

SUITE["batched matrices"]["controlled"] = BenchmarkGroup()
SUITE["batched matrices"]["controlled"]["ordered"] = BenchmarkGroup()
SUITE["batched matrices"]["controlled"]["random"] = BenchmarkGroup()

test_bench(n, U, loc, control_locs, control_bits) =
    instruct!(statevec(rand_state(n)), U, loc, control_locs, control_bits)
for T in [ComplexF64], n = 1:2:5, m = 3:2:6, U in matrices(T, 1 << n), B = 10:20:60
    SUITE["batched matrices"]["controlled"]["ordered"][
        n,
        B,
        m,
        string(T),
        string(typeof(U)),
    ] = bench(n + m, B, U, Tuple(1:n), Tuple(n+1:n+m), ntuple(x -> 1, m))

    perms = randperm(n + m)
    SUITE["batched matrices"]["controlled"]["random"][
        n,
        B,
        m,
        string(T),
        string(typeof(U)),
    ] = bench(n + m, B, U, Tuple(perms[1:n]), Tuple(perms[n+1:n+m]), ntuple(x -> 1, m))
end

# NOTE: ArrayReg shares some common interfaces with Array
"""
    isnormalized(r::ArrayReg) -> Bool

Returns true if the register `r` is normalized.
"""
isnormalized(r::AbstractArrayReg) =
    all(sum(copy(r) |> relax!(to_nactive = nqudits(r)) |> probs, dims = 1) .≈ 1)
isnormalized(r::AdjointRegister) = isnormalized(parent(r))

function isnormalized(r::DensityMatrix)
    return tr(r.state) ≈ 1
end

"""
    normalize!(r::AbstractArrayReg)

Normalize the register `r` by its 2-norm.
It changes the register directly.

### Examples

The following code creates a normalized GHZ state.

```julia
julia> reg = product_state(bit"000") + product_state(bit"111");

julia> norm(reg)
1.4142135623730951

julia> isnormalized(reg)
false

julia> normalize!(reg);

julia> isnormalized(reg)
true
```
"""
function LinearAlgebra.normalize!(r::AbstractArrayReg)
    batch_normalize!(reshape(r.state, :, _asint(nbatch(r))))
    return r
end

LinearAlgebra.normalize!(r::AdjointRegister) = (normalize!(parent(r)); r)

function LinearAlgebra.normalize!(r::DensityMatrix)
    r.state = r.state / tr(r.state)
    return r
end

LinearAlgebra.norm(r::ArrayReg) = norm(statevec(r))
LinearAlgebra.norm(r::BatchedArrayReg) =
    [norm(view(reshape(r.state, :, nbatch(r)), :, ib)) for ib = 1:nbatch(r)]

# basic arithmatics

# neg
Base.:-(reg::Union{AbstractArrayReg{D},DensityMatrix{D}}) where D = chstate(reg, -state(reg))
Base.:-(reg::AdjointRegister) = adjoint(-parent(reg))

# +, -
for op in [:+, :-]
    @eval function Base.$op(lhs::AbstractArrayReg{D}, rhs::AbstractArrayReg{D}) where D
        @assert nbatch(lhs) == nbatch(rhs)
        return chstate(lhs, ($op)(state(lhs), state(rhs)))
    end
    @eval function Base.$op(lhs::DensityMatrix{D}, rhs::DensityMatrix{D}) where D
        @assert nbatch(lhs) == nbatch(rhs)
        return chstate(lhs, ($op)(state(lhs), state(rhs)))
    end
    @eval function Base.$op(
        lhs::AbstractArrayReg{D,T1,<:Transpose},
        rhs::AbstractArrayReg{D,T2,<:Transpose},
    ) where {D,T1,T2}
        @assert nbatch(lhs) == nbatch(rhs)
        return chstate(lhs, transpose(($op)(state(lhs).parent, state(rhs).parent)))
    end

    @eval function Base.$op(lhs::AdjointRegister{D}, rhs::AdjointRegister{D}) where {D}
        r = $op(parent(lhs), parent(rhs))
        return adjoint(r)
    end
end

"""
    regadd!(target, source)

Inplace version of `+` that accumulates `source` to `target`.
"""
function regadd! end

"""
    regsub!(target, source)

Inplace version of `-` that subtract `source` from `target`.
"""
function regsub! end

"""
    regscale!(target, x)

Inplace version of multiplying a scalar `x` to target.
"""
function regscale! end

for T in [:ArrayReg, :DensityMatrix, :BatchedArrayReg]
    @eval function regadd!(lhs::$T{D}, rhs::$T{D}) where {D}
        @assert nbatch(lhs) == nbatch(rhs)
        lhs.state .+= rhs.state
        lhs
    end
    @eval function regsub!(lhs::$T{D}, rhs::$T{D}) where {D}
        @assert nbatch(lhs) == nbatch(rhs)
        lhs.state .-= rhs.state
        lhs
    end
    @eval function regscale!(reg::$T{D}, x) where {D}
        reg.state .*= x
        reg
    end
end

function regadd!(
    lhs::AbstractArrayReg{D,T1,<:Transpose},
    rhs::AbstractArrayReg{D,T2,<:Transpose},
) where {D,T1,T2}
    @assert nbatch(lhs) == nbatch(rhs)
    lhs.state.parent .+= rhs.state.parent
    lhs
end

function regsub!(
    lhs::AbstractArrayReg{D,T1,<:Transpose},
    rhs::AbstractArrayReg{D,T2,<:Transpose},
) where {D,T1,T2}
    @assert nbatch(lhs) == nbatch(rhs)
    lhs.state.parent .-= rhs.state.parent
    lhs
end

function regscale!(reg::AbstractArrayReg{D,T1,<:Transpose}, x) where {D,T1}
    reg.state.parent .*= x
    reg
end

# *, /
for op in [:*, :/]
    @eval function Base.$op(lhs::Union{AbstractArrayReg,DensityMatrix}, rhs::Number)
        chstate(lhs, $op(state(lhs), rhs))
    end

    @eval function Base.$op(lhs::AdjointRegister, rhs::Number)
        r = $op(parent(lhs), rhs')
        return adjoint(r)
    end

    if op == :*
        @eval function Base.$op(lhs::Number, rhs::Union{AbstractArrayReg,DensityMatrix})
            chstate(rhs, lhs * state(rhs))
        end

        @eval function Base.$op(lhs::Number, rhs::AdjointRegister)
            r = lhs' * parent(rhs)
            return adjoint(r)
        end
    end
end

"""
$TYPEDSIGNATURES

The overlap between `ket` and `bra`, which is only defined for two fully activated equal sized registers.
It is only slightly different from [`inner_product`](@ref) in that it always returns a complex number.

### Examples
```jldoctest; setup=:(using YaoArrayRegister)
julia> reg1 = ghz_state(3);

julia> reg2 = uniform_state(3);

julia> reg1' * reg2
0.5 + 0.0im
```
"""
function Base.:*(bra::AdjointRegister{D,<:ArrayReg}, ket::ArrayReg{D})::Number where D
    # check the register sizes
    nqudits(bra) == nqudits(ket) && nremain(bra) == nremain(ket) || error(
            "partially contract ⟨bra|ket⟩ is not supported, expect ⟨bra| and |ket⟩ to have the same size. Got nactive(bra)/nqudits(bra)=$(nactive(bra))/$(nqudits(bra)), nactive(ket)/nqudits(ket)=$(nactive(ket))/$(nqudits(ket))",
        )
    return dot(relaxedvec(parent(bra)), relaxedvec(ket))
end

Base.:*(bra::AdjointRegister{D,<:BatchedArrayReg{D}}, ket::BatchedArrayReg{D}) where D = bra .* ket
function Base.:*(
    bra::AdjointRegister{D,<:BatchedArrayReg{D, T1, <:Transpose}},
    ket::BatchedArrayReg{D,T2,<:Transpose},
) where {D,T1,T2}
    nqudits(bra) == nqudits(ket) && nremain(bra) == nremain(ket) && nbatch(bra) == nbatch(ket) || error(
            "partially contract ⟨bra|ket⟩ is not supported, expect ⟨bra| and |ket⟩ to have the same size. Got nactive(bra)/nqudits(bra)/nbatch(bra)=$(nactive(bra))/$(nqudits(bra))/$(nbatch(bra)), nactive(ket)/nqudits(ket)=$(nactive(ket))/$(nqudits(ket))/$(nbatch(ket))",
        )
    A, C = parent(state(parent(bra))), parent(state(ket))
    res = zeros(eltype(promote_type(T1, T2)), nbatch(ket))
    for j in 1:size(A, 2), i in 1:size(A, 1)
        @inbounds res[i] += conj(A[i, j]) * C[i, j]
    end
    return res
end

# broadcast
broadcastable(r::AdjointRegister{D, <:BatchedArrayReg{D}}) where {D} = (each for each in r)

function Base.:(==)(lhs::AbstractArrayReg, rhs::AbstractArrayReg)
    nbatch(lhs) == nbatch(rhs) &&
    nlevel(lhs) == nlevel(rhs) &&
    state(lhs) == state(rhs)
end

function Base.isapprox(lhs::AbstractArrayReg, rhs::AbstractArrayReg; kw...)
    nbatch(lhs) == nbatch(rhs) &&
    nlevel(lhs) == nlevel(rhs) &&
    isapprox(state(lhs), state(rhs); kw...)
end

Base.:(==)(lhs::AdjointRegister, rhs::AdjointRegister) = parent(lhs) == parent(rhs)
Base.isapprox(lhs::AdjointRegister, rhs::AdjointRegister; kw...) = isapprox(parent(lhs), parent(rhs); kw...)

"""
$(TYPEDSIGNATURES)

Returns true if qudits at `locs` are seperable from the rest qudits.
A state ``|ψ⟩`` is separable if
```math
|\\psi\\rangle = |a\\rangle \\otimes |b\\rangle
```
where ``|a⟩`` is defined on the state space at `locs`.

### Examples
```jldoctest; setup=:(using YaoArrayRegister)
julia> isseparable(product_state(bit"01100"), 1:2)
true

julia> isseparable(ghz_state(5), 1:2)
false
```
"""
function isseparable(reg::AbstractArrayReg{D}, locs) where D
    n = nactive(reg)
    p = length(locs)
    r = reorder!(copy(reg), sortperm([locs..., setdiff(1:n, locs)...]))
    if reg isa BatchedArrayReg
        return all(x->rank(reshape(x.state, D^p, :)) == 1, r)
    else
        return rank(reshape(r.state, D^p, :)) == 1
    end
end

"""
$(TYPEDSIGNATURES)

Remove qubits that are not entangled with the rest qudits safely.
i.e. `isseparable(reg, locs)` must return true.

### Examples
```jldoctest; setup=:(using YaoArrayRegister)
julia> reg = join(ghz_state(3), ghz_state(2));

julia> safe_remove!(copy(reg), 1:2)
ArrayReg{2, ComplexF64, Array...}
    active qubits: 3/3
    nlevel: 2

julia> safe_remove!(copy(reg), 1:3)
ERROR: Qubits at locations 1:3 are entangled with the rest qubits.
[...]
```
"""
function safe_remove!(reg::AbstractArrayReg, locs)
    if isseparable(reg, locs)
        measure!(RemoveMeasured(), reg, locs)
        return reg
    else
        error("Qubits at locations $(locs) are entangled with the rest qubits.")
    end
end

using YaoAPI, TupleTools

# Merge the shape and orders if the orders are contiguous. Returns the
# new merged shape and order.
function contiguous_shape_orders(shape, orders)
    new_shape, new_orders = Int[], Int[]
    prv = -1
    for cur in orders
        if cur == prv + 1
            new_shape[end] *= shape[cur]
        else
            push!(new_orders, cur)
            push!(new_shape, shape[cur])
        end
        prv = cur
    end
    # NOTE: some of the orders are merged above
    #       we use sortperm to retrieve correct
    #       orders
    inv_orders = sortperm(new_orders)
    return new_shape[inv_orders], invperm(inv_orders)
end

# NOTE: don't use Vector for move_ahead, it's way slower!
# Before:
# julia> @benchmark move_ahead($c, $o)
# BenchmarkTools.Trial:
#   memory estimate:  14.87 KiB
#   allocs estimate:  392
#   --------------
#   minimum time:     29.062 μs (0.00% GC)
#   median time:      31.316 μs (0.00% GC)
#   mean time:        39.724 μs (14.37% GC)
#   maximum time:     39.013 ms (99.86% GC)
#   --------------
#   samples:          10000
#   evals/sample:     1
# After:
# julia> @benchmark move_ahead($c, $o)
# BenchmarkTools.Trial:
#   memory estimate:  4.04 KiB
#   allocs estimate:  24
#   --------------
#   minimum time:     2.848 μs (0.00% GC)
#   median time:      3.045 μs (0.00% GC)
#   mean time:        4.013 μs (18.20% GC)
#   maximum time:     4.494 ms (99.86% GC)
#   --------------
#   samples:          10000
#   evals/sample:     9

"""
    move_ahead(collection, orders)

Move `orders` to the beginning of `collection`.
"""
move_ahead(collection, orders) = (orders..., setdiff(collection, orders)...)
move_ahead(ndim::Int, orders) = (orders..., setdiff(1:ndim, orders)...)

function group_permutedims(A::AbstractArray, orders)
    @assert length(orders) == ndims(A) "number of orders does not match number of dimensions"
    return unsafe_group_permutedims(A, orders)
end

# forward directly if the length is the same with ndims
function group_permutedims(A::AbstractArray{T,N}, orders::NTuple{N,Int}) where {T,N}
    return unsafe_group_permutedims(A, orders)
end

function unsafe_group_permutedims(A::AbstractArray, orders)
    s, o = contiguous_shape_orders(size(A), orders)
    return permutedims(reshape(A, s...), o)
end

# Check if the order specified by `locs` is the same as current order.
is_order_same(locs) = all(a == b for (a, b) in zip(locs, 1:length(locs)))

YaoAPI.focus!(locs::Int...) = focus!(locs)
YaoAPI.focus!(locs::NTuple{N,Int}) where {N} = @λ(register -> focus!(register, locs))
YaoAPI.focus!(locs::UnitRange) = @λ(register -> focus!(register, locs))
# NOTE: locations is not the same with orders
# locations: some location of the wire
# orders: includes all the location of the wire in some order
function YaoAPI.focus!(r::AbstractArrayReg{D}, locs) where {D}
    n = nactive(r)
    @assert_locs_safe n (locs...,)
    if is_order_same(locs)
        arr = r.state
    else
        new_orders = move_ahead(n + 1, locs)
        arr = group_permutedims(hypercubic(r), new_orders)
    end
    r.state = reshape(arr, D^length(locs), :)
    return r
end
function YaoAPI.focus(f, r::AbstractRegister, locs::NTuple{N, Int}) where N
    focus!(r, locs)
    ret = f(r)
    relax!(r, locs)
    return ret
end
YaoAPI.focus(f, r::AbstractRegister, locs::Int...) = focus(f, r, locs)

function YaoAPI.relax!(r::AbstractArrayReg{D}, locs; to_nactive::Int = nqudits(r)) where {D}
    r.state = reshape(state(r), D^to_nactive, :)
    if !is_order_same(locs)
        new_orders = TupleTools.invperm(move_ahead(to_nactive + 1, locs))
        r.state = reshape(group_permutedims(hypercubic(r), new_orders), D^to_nactive, :)
    end
    return r
end

YaoAPI.relax!(r::AbstractRegister; to_nactive::Int = nqudits(r)) =
    relax!(r, (); to_nactive = to_nactive)

YaoAPI.relax!(locs::Int...; to_nactive::Union{Nothing,Int} = nothing) =
    relax!(locs; to_nactive = to_nactive)

function YaoAPI.relax!(locs::NTuple{N,Int}; to_nactive::Union{Nothing,Int} = nothing) where {N}
    lambda = function (r::AbstractRegister)
        if to_nactive === nothing
            return relax!(r, locs; to_nactive = nqudits(r))
        else
            return relax!(r, locs; to_nactive = to_nactive)
        end
    end

    @static if VERSION < v"1.1.0"
        return LegibleLambda("(register->relax!(register, locs...; to_nactive))", lambda)
    else
        return LegibleLambda(:(register -> relax!(register, locs...; to_nactive)), lambda)
    end
end

"""
    exchange_sysenv(reg::AbstractArrayReg) -> AbstractRegister

Exchange system (focused qubits) and environment (remaining qubits).

```jldoctest; setup=:(using Yao)
julia> reg = rand_state(5)
ArrayReg{2, ComplexF64, Array...}
    active qubits: 5/5
    nlevel: 2

julia> focus!(reg, (2,4))
ArrayReg{2, ComplexF64, Array...}
    active qubits: 2/5
    nlevel: 2

julia> exchange_sysenv(reg)
ArrayReg{2, ComplexF64, Adjoint...}
    active qubits: 3/5
    nlevel: 2
```
"""
function exchange_sysenv(reg::BatchedArrayReg)
    r3 = rank3(reg)
    M, N, B = size(r3)
    arrayreg(reshape(permutedims(r3, (2, 1, 3)), :, M*B); nbatch=nbatch(reg), nlevel=nlevel(reg))
end
function exchange_sysenv(reg::ArrayReg{D}) where D
    ArrayReg{D}(reg.state')
end

using YaoArrayRegister
using Test

@testset "test utils" begin
    include("utils.jl")
    include("error.jl")
end

@testset "test ArrayReg" begin
    include("register.jl")
    include("operations.jl")
    include("focus.jl")
end

@testset "test instructions" begin
    include("instruct.jl")
end

@testset "test qudit instructions" begin
    include("qudit_instruct.jl")
end

@testset "test measure" begin
    include("measure.jl")
end

@testset "test density matrix" begin
    include("density_matrix.jl")
end

"""
YaoArrayRegister.jl is a component package in the [Yao.jl](https://github.com/QuantumBFS/Yao.jl) ecosystem.
It provides the most basic functionality for quantum
computation simulation in Julia and a quantum register type `ArrayReg`. You will be
able to simulate a quantum circuit alone with this package in principle.
"""
module YaoArrayRegister

using Adapt
using YaoAPI
using BitBasis
using LinearAlgebra
using LegibleLambdas
using StatsBase, Random
using StaticArrays
import LuxurySparse: fastkron, IMatrix, PermMatrix, Diagonal, SparseMatrixCSC
using DocStringExtensions

export AbstractArrayReg,
    ArrayReg,
    BatchedArrayReg,
    AdjointArrayReg,
    ArrayRegOrAdjointArrayReg,
    NoBatch,
    arrayreg,
    transpose_storage,
    datatype,
    # initialization
    product_state,
    zero_state,
    zero_state_like,
    rand_state,
    rand_density_matrix,
    completely_mixed_state,
    is_density_matrix,
    ghz_state,
    uniform_state,
    oneto,
    # additional
    state,
    statevec,
    relaxedvec,
    rank3,
    # operations
    isnormalized,
    isseparable,
    safe_remove!,
    normalize!,
    norm,
    regadd!,
    regsub!,
    regscale!,
    exchange_sysenv,
    print_table

# BitBasis
export @bit_str, @dit_str, BitStr, DitStr, hypercubic

# YaoAPI
export AbstractRegister,
    AdjointRegister,
    AllLocs,
    ComputationalBasis,
    DensityMatrix,
    LocationConflictError,
    NoPostProcess,
    NotImplementedError,
    PostProcess,
    QubitMismatchError,
    RemoveMeasured,
    ResetTo,
    append_qudits!,
    append_qubits!,
    collapseto!,
    density_matrix,
    von_neumann_entropy,
    mutual_information,
    fidelity,
    fidelity2,
    focus!,
    focus,
    insert_qudits!,
    insert_qubits!,
    most_probable,
    instruct!,
    accum_instruct!,
    invorder!,
    measure,
    measure!,
    nactive,
    nbatch,
    nlevel,
    nqubits,
    nqudits,
    nremain,
    partial_tr,
    probs,
    purify,
    relax!,
    reorder!,
    select,
    select!,
    tracedist,
    viewbatch,
    basis,
    clone,
    @assert_locs_safe,
    @assert_locs_inbounds

# matrix types
export IMatrix, PermMatrix, Diagonal, SparseMatrixCSC

# others
export Const, logdi

include("utils.jl")
include("ast_tools.jl")
include("error.jl")
include("constants.jl")
include("register.jl")
include("density_matrix.jl")
include("operations.jl")
include("focus.jl")

include("instruct.jl")
include("qudit_instruct.jl")
include("measure.jl")

include("deprecations.jl")

end # module

using YaoArrayRegister
using Test, LinearAlgebra
using SparseArrays: sprand

@testset "utils" begin
    @test YaoArrayRegister.map_index(Val(3), 5, (1,3)) == 5
    @test YaoArrayRegister.map_index(Val(3), 5, (3,1)) == 7
end

@testset "operators" begin
    state = rand_state(6) |> statevec
    # general matrix
    for m in [YaoArrayRegister.IMatrix{ComplexF64}(4), randn(ComplexF64, 4, 4), YaoArrayRegister.pmrand(ComplexF64, 4), Diagonal(randn(ComplexF64, 4)), sprand(ComplexF64, 4, 4, 0.5)]
        @info "qudit gate, matrix type: ", typeof(m)
        expected = instruct!(Val(2), state, m, (3,4))
        @test expected ≈ instruct!(Val(4), state, m, (2,))
    end
end

@testset "corner cases" begin
    state = rand_state(2) |> statevec
    # matrix size same as register size
    m = randn(ComplexF64, 4, 4)
    expected = instruct!(Val(2), state, m, (1,2))
    @test expected ≈ instruct!(Val(4), state, m, (1,))

    # an case that breaks during test
    state = randn(ComplexF64, 3)
    m = sparse([1, 2], [2,1], [1.0+0im, 1.0], 3, 3)
    expected = m * state
    @test expected ≈ instruct!(Val(3), state, m, (1,))
end

using Test, YaoArrayRegister, BitBasis, YaoAPI

function naive_focus!(reg::AbstractArrayReg{D}, bits) where {D}
    B = YaoArrayRegister._asint(nbatch(reg))
    nbits = nqubits(reg)
    norder = vcat(bits, setdiff(1:nbits, bits), nbits + 1)
    @views reg.state = reshape(
        permutedims(reshape(reg.state, fill(D, nbits)..., B), norder),
        :,
        (D ^ (nbits - length(bits))) * B,
    )
    return reg
end

function naive_relax!(reg::AbstractArrayReg{D}, bits) where {D}
    B = YaoArrayRegister._asint(nbatch(reg))
    nbit = nqubits(reg)
    norder = vcat(bits, setdiff(1:nbit, bits), nbit + 1) |> invperm
    @views reg.state =
        reshape(permutedims(reshape(reg.state, fill(D, nbit)..., B), norder), :, B)
    return reg
end


@testset "Focus 1" begin
    reg0 = rand_state(5; nbatch = 3)
    @test focus!(copy(reg0), [1, 4, 2]) == naive_focus!(copy(reg0), [1, 4, 2])
    @test copy(reg0) |>
          focus!(1, 4, 2) |>
          focus!(2) |>
          relax!(2, to_nactive = 3) |>
          relax!(1, 4, 2) == reg0
    reg = focus!(copy(reg0), 2:3)
    @test reg |> probs ≈
          hcat([sum(abs2.(reshape(reg.state[i, :], :, 3)), dims = 1)[1, :] for i = 1:4]...)'
    @test size(state(reg)) == (2^2, 2^3 * 3)
    @test nactive(reg) == 2
    @test nremain(reg) == 3
    @test relax!(reg, 2:3) == reg0
end

@testset "Focus 3" begin
    # conanical shape
    reg = rand_state(3; nbatch = 5)
    @test oneto(reg, 2) |> nactive == 2
    @test reg |> nactive == 3
    @test copy(reg) |> append_qudits!(2) |> nactive == 5
    reg2 = copy(reg) |> append_qudits!(2) |> focus!(4, 5)
    @test (measure!(RemoveMeasured(), reg2); reg2) |> relax!(to_nactive = nqubits(reg2)) ≈
          reg

    @test insert_qudits!(copy(reg), 2, 2) |> nactive == 5
    @test insert_qubits!(copy(reg), 2, 2) |> nactive == 5
    @test insert_qudits!(2, 2)(copy(reg)) |> nactive == 5
    @test insert_qubits!(2, 2)(copy(reg)) |> nactive == 5
end

@testset "Focus 2" begin
    reg0 = rand_state(8)
    reg = focus!(copy(reg0), 7)
    @test reg |> probs ≈ sum(abs2.(reg.state), dims = 2)[:, 1]
    @test nactive(reg) == 1

    reg0 = rand_state(10)
    reg = focus!(copy(reg0), 1:8)
    @test hypercubic(reg) == reshape(reg0.state, fill(2, 8)..., 4)
    @test nactive(reg) == 8
    @test reg0 == relax!(reg, 1:8)
end

@testset "focus do ... end" begin
    reg = rand_state(5)
    focus(reg, (1, 2, 3)) do reg
        @test nactive(reg) == 3
    end
    @test nactive(reg) == 5

    reg = rand_state(5)
    focus(reg, 1, 2, 3) do reg
        @test nactive(reg) == 3
    end
    @test nactive(reg) == 5

    reg = rand_state(5)
    focus(reg, 1) do reg
        @test nactive(reg) == 1
    end
    @test nactive(reg) == 5
end

@testset "partial trace" begin
    @test partial_tr(1) isa YaoArrayRegister.LegibleLambda
end

@testset "contiguous shape order" begin
    @test YaoArrayRegister.contiguous_shape_orders((2, 3, 4), (1, 2, 3)) == ([24], [1])
end

export ASTTools

"""
    ASTTools

Tools for manipulating Julia ASTs. This module provides similar functionality
with MacroTools, but based on MLStyle.
"""
module ASTTools

using MLStyle
export @capture

# capture
function capturing_analysis(expr, out, is_literal)

    @match expr begin
        ::QuoteNode => capturing_analysis(expr.value, out, true)

        if is_literal
        end && Expr(:$, args...) => foreach(x -> capturing_analysis(x, out, false), args)

        if is_literal
        end && Expr(_, args...) => foreach(x -> capturing_analysis(x, out, true), args)


        if is_literal
        end && _ => nothing


        # not literal
        ::Symbol => (push!(out, expr); nothing)

        Expr(:quote, args...) => foreach(x -> capturing_analysis(x, out, true), args)

        :(Do($(args...))) => foreach(args) do arg
            @match arg begin
                Expr(:kw, key::Symbol, value) => begin
                    push!(out, key)
                end
                _ => nothing
            end
        end
        :($a || $b) => let out1 = Set(Symbol[]), out2 = Set(Symbol[])
            capturing_analysis(a, out1, false)
            capturing_analysis(b, out2, false)

            union!(out, intersect(out1, out2))
            nothing
        end
        # type pattern
        Expr(:(::), a, _) => capturing_analysis(a, out, false)
        # dict pattern
        :(Dict($(args...))) => foreach(args) do arg
            @match arg begin
                :($_ => $v) => capturing_analysis(v, out, false)
                _ => nothing
            end
        end
        # app pattern
        :($_($(args...))) => foreach(x -> capturing_analysis(x, out, false), args)
        # other expr
        Expr(_, args...) => foreach(x -> capturing_analysis(x, out, false), args)
        # ref pattern
        Expr(:&, _) ||
            # predicate
            Expr(:function, _...) ||
            Expr(:if, _...) ||
            x => nothing
    end
end

function capture(template)
    syms = Set(Symbol[])
    capturing_analysis(template, syms, true)
    out_expr =
        Expr(:call, Dict, (Expr(:call, =>, QuoteNode(each), each) for each in syms)...)
    arg_sym = gensym()
    let template = Expr(:quote, template)
        quote
            $arg_sym -> $MLStyle.@match $arg_sym begin
                $(template) => $(out_expr)
            end
        end
    end
end

"""
    @capture template
    @capture template expr

Template matching for expressions.

```julia
julia> @capture f(\$x)  :(f(2))
Dict{Symbol,Int64} with 1 entry:
  :x => 2
```
"""
:(@capture)

macro capture(template)
    capture(template) |> esc
end

macro capture(template, ex)
    Expr(:call, capture(template), ex) |> esc
end

end

using Test, YaoArrayRegister, BitBasis, LinearAlgebra
using YaoAPI
using Adapt

@testset "test ArrayReg constructors" begin
    @test ArrayReg(rand(4)) isa ArrayReg{2}
    @test_logs (:warn, "Input matrix element type is not `Complex`, got `Float64`") ArrayReg(
        rand(4, 4),
    )
    @test ArrayReg(rand(ComplexF64, 4)) isa ArrayReg{2}
    @test ArrayReg(arrayreg(bit"101")) == arrayreg(bit"101")

    st = rand(ComplexF64, 4, 8)
    @test state(adjoint(ArrayReg(st))) == adjoint(st)

    @test state(arrayreg(bit"101")) == reshape(onehot(bit"101"), :, 1)
    @test datatype(arrayreg(ComplexF32, bit"101")) == ComplexF32

    st = rand(ComplexF64, 4, 8)
    reg= ArrayReg{2}(st)
    @test similar(reg) isa ArrayReg
    @test nactive(similar(reg)) == 2
    m = randn(ComplexF64, 8, 8)
    @test similar(reg, m).state == m
    @test viewbatch(reg, 1) == reg
    @test_throws ErrorException viewbatch(reg, 2)

    reg = rand_state(3; nlevel=3, nbatch=2) |> focus!((2,3))
    print_table(reg)
end

@testset "test BatchedArrayReg constructors" begin
    @test BatchedArrayReg(rand_state(3), rand_state(3; nbatch=3), rand_state(3)).nbatch == 5
    @test BatchedArrayReg(rand(4, 6), 3) isa BatchedArrayReg{2}
    @test_throws DimensionMismatch BatchedArrayReg(rand(4, 3), 2)
    @test_throws DimensionMismatch BatchedArrayReg(rand(5, 2), 2)
    @test BatchedArrayReg(rand(ComplexF64, 4, 3)) isa BatchedArrayReg{2}

    @test state(arrayreg(bit"101"; nbatch=2)) == repeat(reshape(onehot(bit"101"), :, 1), 1, 2)
    @test datatype(arrayreg(ComplexF32, bit"101"; nbatch=2)) == ComplexF32

    st = rand(ComplexF64, 4, 6)
    reg = BatchedArrayReg(st, 6)
    regt = transpose_storage(reg)
    @test regt.state isa Transpose
    @test regt == reg
    @test transpose_storage(regt).state isa Matrix
    @test transpose_storage(regt) == reg
    @test_throws ErrorException ArrayReg(reg)

    reg = zero_state(5; nbatch=1)
    @test reg isa BatchedArrayReg
    r2 = ArrayReg(reg)
    @test r2 isa ArrayReg
    @test BatchedArrayReg(r2) == reg

    st = rand(ComplexF64, 4, 8)
    reg= BatchedArrayReg{2}(st, 4)
    @test similar(reg) isa BatchedArrayReg
    @test nactive(similar(reg)) == 2
    @test nqubits(similar(reg)) == 3
    m = randn(ComplexF64, 8, 8)
    @test similar(reg, m).state == m

    @test ghz_state(3) ≈ normalize!(zero_state(3) + product_state(bit"111"))
end

@testset "test $T initialization methods" for T in [ComplexF64, ComplexF32, ComplexF16]
    @testset "test product state" begin
        reg = product_state(T, bit"100")
        st = state(reg)
        @test nqudits(reg) == 3
        @test !(st isa Transpose)
        st2 = state(product_state(T, [0, 0, 1]))
        @test st2 ≈ st
        st = state(product_state(T, bit"100"; nbatch = 2, no_transpose_storage = true))
        @test !(st isa Transpose)
        st = state(product_state(T, bit"100"; nbatch = 2))
        @test st isa Transpose
        for k = 1:2
            @test st[:, k] ≈ onehot(T, bit"100")
        end

        st = state(product_state(T, 4, 0; nbatch = 3))
        for k = 1:3
            @test st[:, k] ≈ onehot(T, BitStr64{4}(0))
        end
        @test eltype(product_state(Float64, 4, 0).state) == Float64
    end
    @testset "test zero state" begin
        st = state(zero_state(T, 3))
        @test !(st isa Transpose)
        st = state(zero_state(T, 3; nbatch = 2, no_transpose_storage = true))
        @test !(st isa Transpose)
        st = state(zero_state(T, 4; nbatch = 4))
        @test st isa Transpose
        for k = 1:4
            @test st[:, k] ≈ onehot(T, BitStr64{4}(0))
        end
        @test eltype(zero_state(Float64, 4).state) == Float64
    end
    @testset "test rand state" begin
        st = state(rand_state(T, 3))
        @test !(st isa Transpose)
        st = state(rand_state(T, 3; nbatch = 2, no_transpose_storage = true))
        @test !(st isa Transpose)
        # NOTE: we only check if the state is normalized
        st = state(rand_state(T, 4, nbatch = 2))
        @test st isa Transpose
        for k = 1:2
            @test norm(st[:, k]) ≈ 1.0
        end
        @test eltype(rand_state(Float64, 4).state) == Float64
    end
    @testset "test uniform state" begin
        st = state(uniform_state(T, 3))
        @test !(st isa Transpose)
        st = state(uniform_state(T, 3; nbatch = 2, no_transpose_storage = true))
        @test !(st isa Transpose)
        st = state(uniform_state(T, 4; nbatch = 2))
        @test st isa Transpose
        for k = 1:2
            for each in st[:, k]
                @test each ≈ 1 / sqrt(16)
            end
        end
        @test eltype(uniform_state(Float64, 4).state) == Float64
    end
    @testset "test oneto" begin
        r1 = uniform_state(ComplexF64, 4)
        r2 = oneto(r1, 2)
        @test nactive(r2) == 2
        @test r1 |> oneto(2) |> nactive == 2
    end
    @testset "test clone" begin
        r = clone(arrayreg(T, bit"101"; nbatch=3), 4)
        @test nactive(r) == 3
        @test nbatch(r) == 12
    end
end

@testset "test YaoAPI interface" begin
    @testset "test probs" begin
        r = rand_state(5; nbatch = 3)
        @test probs(r) ≈ abs2.(state(r))
        r = rand_state(5)
        @test probs(r) ≈ abs2.(state(r))
    end
    @testset "test batch iteration" begin
        r = arrayreg(bit"101"; nbatch= 3)
        for k = 1:3
            @test viewbatch(r, k) == arrayreg(bit"101")
        end
        # broadcast
        for each in r
            @test each == arrayreg(bit"101")
        end
    end
    @testset "test append_qudits!" begin
        @test append_qudits!(zero_state(3), 3) == zero_state(6)
        r = rand_state(3; nbatch = 2)
        @test append_qudits!(copy(r), 2) ≈ join(zero_state(2; nbatch = 2), r)
        r = rand_state(3; nbatch = 1)
        @test append_qudits!(copy(r), 2) ≈ join(zero_state(2; nbatch = 1), r)
        @test copy(r) |> append_qubits!(2) ≈ join(zero_state(2; nbatch = 1), r)
    end
end

@testset "test statevec" begin
    r = arrayreg(bit"101"; nbatch=3)
    @test statevec(r) == r.state
    r = oneto(r, 2)
    @test statevec(r) == reshape(state(r), 4, 6)
end

@testset "test hypercubic" begin
    @test hypercubic(rand_state(3)) |> size == (2, 2, 2, 1)
end

# TODO: test concat multiple registers
@testset "test join" begin
    r1 = rand_state(6)
    r2 = rand_state(6)
    r3 = join(r2, r1)
    r4 = join(focus!(copy(r2), 1:2), focus!(copy(r1), 1:3))
    @test r4 |> relaxedvec ≈
          focus!(copy(r3), [1, 2, 3, 7, 8, 4, 5, 6, 9, 10, 11, 12]) |> relaxedvec
    reg5 = focus!(clone(r1, 3), 1:3)
    reg6 = focus!(clone(r2, 3), 1:2)
    @test (join(reg6, reg5)|>relaxedvec)[:, 1] ≈ r4 |> relaxedvec

    # manual trace
    r = join(arrayreg(bit"011"), zero_state(1))
    focus!(r, 2:4)
    @test sum(r.state, dims = 2) ≈ arrayreg(bit"011").state
end

@testset "YaoBlocks.jl/issues/21" begin
    st = rand(ComplexF64, 16, 2)
    r1 = ArrayReg(view(st, :, 1))
    r2 = ArrayReg(rand(ComplexF64, 16, 1))
    copyto!(r1, r2)
    @test r1 == r2
end

@testset "transpose copy" begin
    reg = rand_state(5; nbatch = 10)
    reg1 = copy(reg)
    reg2 = focus!(copy(reg), (3, 5))
    reg3 = relax!(copy(reg2), (3, 5))
    reg4 = oneto(reg1, 3)
    @test reg1.state isa Transpose
    @test reg2.state isa Transpose
    @test reg3.state isa Transpose
    @test reg4.state isa Transpose
    @test reg4.state ≈ oneto(reg, 3).state
    reg4.state[1] = 2.0
    @test reg.state[1] != 2.0
end

@testset "collapseto" begin
    reg = rand_state(4)
    reg2 = copy(reg)
    focus!(reg, (4, 2))
    collapseto!(reg, bit"01")
    relax!(reg, (4, 2), to_nactive = 4)
    instruct!(reg2, Const.P0, (2,))
    instruct!(reg2, Const.P1, (4,))
    normalize!(reg2)
    @test reg ≈ reg2
end

@testset "overlap between two focused reg" begin
    rega = rand_state(5)
    regb = rand_state(5)
    reg1 = focus!(copy(rega), (3, 2, 4))
    reg2 = focus!(copy(regb), (3, 2, 4))
    @test reg1' * reg2 ≈ rega' * regb
end

@testset "adapt" begin
    @test datatype(adapt(Array{ComplexF32}, zero_state(5))) == ComplexF32
end

@testset "von_neumann_entropy" begin
    reg = (product_state(bit"00000") + product_state(bit"11111")) / sqrt(2)
    @test von_neumann_entropy(reg, [2,3]) ≈ log(2)
    @test mutual_information(reg, [2,3], [5]) ≈ log(2)
end

@testset "qudit" begin
    reg = ArrayReg{3}(reshape(randn(ComplexF64, 9), :, 1))
    @test nlevel(reg) == 3
    @test nactive(reg) == 2
    @test_throws MethodError nqubits(reg)
    @test nqudits(reg) == 2

    # constructors
    reg = zero_state(2; nlevel=3)
    @test statevec(reg) == [1.0, 0.0im, 0, 0, 0, 0, 0, 0, 0]
    @test statevec(product_state(2, 1; nlevel=3)) == [0.0, 1.0+0.0im, 0, 0, 0, 0, 0, 0, 0]
    @test length(statevec(rand_state(2; nlevel=3))) == 9
    @test size(statevec(zero_state(2; nbatch=5, nlevel=3))) == (9,5)
end

@testset "more (push test coverage)" begin
    reg1 = transpose_storage(rand_state(3; nbatch=5))
    reg2 = transpose_storage(rand_state(3; nbatch=5))
    res = reg1' * reg2
    @test res ≈ (reg1') .* reg2

    reg = transpose_storage(focus!(rand_state(6), [2,3]))
    @test reg.state isa Transpose
    @test copy(reg).state isa Transpose
    
    copyto!(reg1', reg2')
    @test reg1 ≈ reg2
    @test reorder!(reg1, [2,3,1]).state ≈ reshape(permutedims(reshape(reg2.state, 2, 2, 2, 5), sortperm([2,3,1,4])), 8, 5)

    reg = product_state(bit"010101")
    @test invorder!(reg) ≈ product_state(bit"101010")
end

@testset "most_probable" begin
    reg = arrayreg(ComplexF64[0.0, 0.6, 0.8, 0.0])
    reg2 = arrayreg(ComplexF64[0.0, 0.6, 0.0, 0.8])
    mp = most_probable(reg, 1)
    @test length(mp) == 1 && mp[1] === BitStr{2}(2)
    @test most_probable(reg, 2) == BitStr{2}.([2, 1])
    breg = BatchedArrayReg(reg, reg2)
    @test most_probable(breg, 2) == BitStr{2}.([2 3; 1 1])
    reg1 = 0.6 * arrayreg(dit"120;3") + 0.8 * arrayreg(dit"222;3")
    reg2 = 0.8 * arrayreg(dit"120;3") + 0.6 * arrayreg(dit"222;3")
    @test most_probable(reg1, 1) == [dit"222;3"]
    @test most_probable(BatchedArrayReg(reg1, reg2), 1) == reshape([dit"222;3", dit"120;3"], 1, :)
end

@testset "mock register" begin
    # mocked registers
    struct TestRegister <: AbstractRegister{2} end

    YaoArrayRegister.nqudits(::TestRegister) = 8
    YaoArrayRegister.nactive(::TestRegister) = 2

    export TestInterfaceRegister
    struct TestInterfaceRegister <: AbstractRegister{2} end

    @testset "Test general interface" begin
        @test_throws MethodError nactive(TestInterfaceRegister())
        @test_throws MethodError nqubits(TestInterfaceRegister())
        @test_throws MethodError nremain(TestInterfaceRegister())
    end

    @testset "adjoint register" begin
        @test adjoint(TestRegister()) isa AdjointRegister
        @test adjoint(adjoint(TestRegister())) isa TestRegister
        @test nqubits(adjoint(TestRegister())) == 8
        @test nactive(adjoint(TestRegister())) == 2
    end
end

@testset "zero_state_like" begin
    @test zero_state_like(rand_state(3), 4) ≈ zero_state(4)
    @test zero_state_like(rand_state(3; nbatch=4), 4) ≈ zero_state(4; nbatch=4)
end

@testset "basis" begin
    @test basis(rand_state(3)) == bit"000":bit"111"
    reg = product_state(dit"120;3")
    @test reg[dit"120;3"] == 1.0
    @test reg[dit"121;3"] == 0.0
end

import BitBasis: BitStr, BitStr64

"""
    AbstractArrayReg

Abstract type for quantum registers that are represented by an array.
"""
abstract type AbstractArrayReg{D,T,AT} <: AbstractRegister{D} end

struct NoBatch end
_asint(x::Int) = x
_asint(::NoBatch) = 1

# interfaces
YaoAPI.nremain(r::AbstractRegister) = nqudits(r) - nactive(r)
YaoAPI.nlevel(r::AbstractRegister{D}) where {D} = D
YaoAPI.nqubits(r::AbstractRegister{2}) = nqudits(r)

# conrete implementations

"""
    ArrayReg{D,T,MT<:AbstractMatrix{T}} <: AbstractArrayRegister{D}
    ArrayReg{D}(raw)
    ArrayReg(raw::AbstractVecOrMat; nlevel=2)
    ArrayReg(r::ArrayReg)

Simulated full amplitude register type, it uses an array to represent
corresponding one or a batch of quantum states. `T`
is the numerical type for each amplitude, it is `ComplexF64` by default.

!!! warning

    `ArrayReg` constructor will not normalize the quantum state. If you need a
    normalized quantum state remember to use `normalize!(register)` on the register.
"""
mutable struct ArrayReg{D,T,MT<:AbstractMatrix{T}} <: AbstractArrayReg{D,T,MT}
    state::MT
    function ArrayReg{D,T,MT}(state::MT) where {D,T, MT<:AbstractMatrix{T}}
        _check_reg_input(state, D, 1)
        return new{D,T,MT}(state)
    end
end

ArrayReg(raw; nlevel=2) = ArrayReg{nlevel}(raw)
ArrayReg{D}(raw::AbstractVector) where D = ArrayReg{D}(reshape(raw, :, 1))
function ArrayReg{D}(raw::MT) where {D,T,MT<:AbstractMatrix{T}}
    return ArrayReg{D,T,MT}(raw)
end

ArrayReg(r::ArrayReg{D}) where {D} = ArrayReg{D}(copy(r.state))
ArrayReg(r::ArrayReg{D,T,<:Transpose}) where {D,T} =
        ArrayReg{D}(Transpose(copy(r.state.parent)))

Base.copy(r::ArrayReg) = ArrayReg(r)
Base.similar(r::ArrayReg{D}) where D = ArrayReg{D}(similar(state(r)))
Base.similar(r::ArrayReg{D}, state::AbstractMatrix) where D = ArrayReg{D}(state)

"""
    BatchedArrayReg{D,T,MT<:AbstractMatrix{T}} <: AbstractArrayReg{D}
    BatchedArrayReg(raw, nbatch; nlevel=2)
    BatchedArrayReg{D}(raw, nbatch)

Simulated batched full amplitude register type, it uses an array to represent
corresponding one or a batch of quantum states. `T`
is the numerical type for each amplitude, it is `ComplexF64` by default.

!!! warning

    `BatchedArrayReg` constructor will not normalize the quantum state. If you need a
    normalized quantum state remember to use `normalize!(register)` on the register.
"""
mutable struct BatchedArrayReg{D,T,MT<:AbstractMatrix{T}} <: AbstractArrayReg{D,T,MT}
    state::MT
    nbatch::Int
    function BatchedArrayReg{D,T,MT}(state::MT, nbatch::Int) where {D,T, MT<:AbstractMatrix{T}}
        _check_reg_input(state, D, nbatch)
        return new{D,T,MT}(state, nbatch)
    end
end
BatchedArrayReg(raw::AbstractMatrix, nbatch::Int=size(raw, 2); nlevel=2) = BatchedArrayReg{nlevel}(raw, nbatch)
function BatchedArrayReg{D}(raw::MT, nbatch::Int) where {D,T,MT<:AbstractMatrix{T}}
    return BatchedArrayReg{D,T,MT}(raw, nbatch)
end

BatchedArrayReg(r::BatchedArrayReg{D}) where {D} = BatchedArrayReg{D}(copy(r.state), r.nbatch)
BatchedArrayReg(r::BatchedArrayReg{D,T,<:Transpose}) where {D,T} =
        BatchedArrayReg{D}(Transpose(copy(r.state.parent)), r.nbatch)

function BatchedArrayReg(reg0::AbstractArrayReg{D}, regs::AbstractArrayReg{D}...) where D
    n = nqudits(reg0)
    na = nactive(reg0)
    @assert all(reg->nqudits(reg) == n && nactive(reg) == na, regs) "Number of (active) qudits do not match."
    state = cat(rank3(reg0), rank3.(regs)...; dims=3)
    return BatchedArrayReg{D}(reshape(state, :, size(state, 3)), size(state, 3))
end

Base.copy(r::BatchedArrayReg) = BatchedArrayReg(r)
Base.similar(r::BatchedArrayReg{D}) where D = BatchedArrayReg{D}(similar(state(r)), r.nbatch)
Base.similar(r::BatchedArrayReg{D}, state::AbstractMatrix) where D = BatchedArrayReg{D}(state, r.nbatch)
YaoAPI.viewbatch(r::ArrayReg, ind::Int) = ind == 1 ? r : error("Index `$ind` out of bounds, should be `1`.")

# convert
function ArrayReg(r::BatchedArrayReg{D}) where D
    if nbatch(r) != 1
        error("can not convert a `BatchedArrayReg` with `nbatch != 1` to a `ArrayReg`")
    else
        return ArrayReg{D}(r.state)
    end
end
BatchedArrayReg(r::ArrayReg{D}...) where D = BatchedArrayReg{D}(hcat(state.(r)...), length(r))

function _check_reg_input(raw::AbstractMatrix{T}, D::Integer, B::Integer) where T
    _warn_type(raw)
    if D <= 0
        error("invalid number of level: $D")
    end
    if B < 0
        error("invalid batch size: $B")
    end
    ispow(size(raw, 1), D) ||
        throw(DimensionMismatch("Expect first dimension size to be power of $D"))
    if !(ispow(size(raw, 2) ÷ B, D) && size(raw, 2) % B == 0)
        throw(
            DimensionMismatch(
                "Expect second dimension size to be $D^n multiple of batch size $B",
            ),
        )
    end
end

function _warn_type(raw::AbstractMatrix{T}) where T
    T <: Complex || @warn "Input matrix element type is not `Complex`, got `$(eltype(raw))`"
end

"""
    arrayreg(state; nbatch::Union{Integer,NoBatch}=NoBatch(), nlevel::Integer=2)

Create an array register, if nbatch is a integer, it will return a `BatchedArrayReg`.
"""
function arrayreg(state; nbatch::Union{Integer,NoBatch}=NoBatch(), nlevel::Integer=2)
    if nbatch isa NoBatch
        return ArrayReg{nlevel}(state)
    else
        return BatchedArrayReg{nlevel}(state, nbatch)
    end
end

Adapt.@adapt_structure ArrayReg
Adapt.@adapt_structure BatchedArrayReg

"""
    AdjointArrayReg{D,T,MT} = AdjointRegister{D,<:AbstractArrayReg{D,T,MT}}

Adjoint array register type, it is used to represent the bra in the Dirac notation.
"""
const AdjointArrayReg{D,T,MT} = AdjointRegister{D,<:AbstractArrayReg{D,T,MT}}
const ArrayRegOrAdjointArrayReg{D,T,MT} =
    Union{AbstractArrayReg{D,T,MT},AdjointArrayReg{D,T,MT}}

Base.parent(reg::AdjointRegister) = reg.parent

function Base.summary(io::IO, reg::AdjointRegister{B,RT}) where {B,RT}
    print(io, "adjoint(", summary(reg.parent), ")")
end

"""
    adjoint(register) -> register

Lazy adjoint for quantum registers.
"""
Base.adjoint(reg::AbstractRegister) = AdjointRegister(reg)
Base.adjoint(reg::AdjointRegister) = parent(reg)

YaoAPI.viewbatch(reg::AdjointRegister, i::Int) = adjoint(viewbatch(parent(reg), i))

for FUNC in [:nqudits, :nremain, :nactive]
    @eval YaoAPI.$FUNC(r::AdjointRegister) = $FUNC(r.parent)
end

"""
    datatype(register) -> Int

Returns the numerical data type used by register.

!!! note

    `datatype` is not the same with `eltype`, since `AbstractRegister` family
    is not exactly the same with `AbstractArray`, it is an iterator of several
    registers.
"""
datatype(r::AbstractArrayReg{D,T}) where {D,T} = T

"""
    arrayreg([T=ComplexF64], bit_str; nbatch=NoBatch())

Construct an array register from bit string literal.
For bit string literal please read [`@bit_str`](@ref).

### Examples

```jldoctest; setup=:(using Yao)
julia> arrayreg(bit"1010")
ArrayReg{2, ComplexF64, Array...}
    active qubits: 4/4
    nlevel: 2

julia> arrayreg(ComplexF32, bit"1010")
ArrayReg{2, ComplexF32, Array...}
    active qubits: 4/4
    nlevel: 2
```
"""
arrayreg(ditstr::DitStr; nbatch::Union{Int,NoBatch}=NoBatch()) = arrayreg(ComplexF64, ditstr; nbatch=nbatch)
arrayreg(::Type{T}, ditstr::DitStr{D}; nbatch::Union{Int,NoBatch}=NoBatch()) where {T,D} = arrayreg(onehot(T, ditstr; nbatch=_asint(nbatch)); nbatch=nbatch, nlevel=D)

"""
    transpose_storage(register) -> register

Transpose the register storage. Sometimes transposed storage provides better performance for batched simulation.
"""
transpose_storage(reg::AbstractArrayReg{D,T,<:Transpose}) where {D,T} = arrayreg(copy(reg.state); nbatch=nbatch(reg), nlevel=D)
transpose_storage(reg::AbstractArrayReg) =
    arrayreg(transpose(copy(transpose(reg.state))); nbatch=nbatch(reg), nlevel=nlevel(reg))

# NOTE: ket bra is not copyable
function Base.copyto!(dst::AbstractArrayReg, src::AbstractArrayReg)
    copyto!(state(dst), state(src))
    return dst
end

function Base.copyto!(dst::AdjointArrayReg, src::AdjointArrayReg)
    copyto!(state(dst), state(src))
    return dst
end

# register interface
YaoAPI.nqudits(r::AbstractArrayReg{2}) = log2i(length(r.state) ÷ _asint(nbatch(r)))
YaoAPI.nqudits(r::AbstractArrayReg{D}) where {D} = logdi(length(r.state) ÷ _asint(nbatch(r)), D)
YaoAPI.nactive(r::AbstractArrayReg{D}) where {D} = logdi(size(r.state, 1), D)
YaoAPI.viewbatch(r::BatchedArrayReg{D}, ind::Int) where D = @inbounds ArrayReg{D}(view(rank3(r), :, :, ind))

YaoAPI.append_qudits!(n::Int) = @λ(register -> append_qudits!(register, n))
function YaoAPI.append_qudits!(r::AbstractArrayReg{D,T}, n::Int) where {D,T}
    raw = state(r)
    M, N = size(raw)
    r.state = similar(r.state, M * (D ^ n), N)   # NOTE: does not preserve adjoint
    fill!(r.state, zero(T))
    r.state[1:M, :] = raw
    return r
end
YaoAPI.append_qubits!(reg::AbstractRegister{2}, nqubits::Int) = append_qudits!(reg, nqubits)
YaoAPI.append_qubits!(nqubits::Int) =
    @λ(register -> append_qubits!(register, nqubits))

YaoAPI.insert_qubits!(loc::Int, nqubits::Int) =
    @λ(register -> insert_qubits!(register, loc, nqubits))
YaoAPI.insert_qubits!(reg::AbstractRegister{2}, loc::Int, nqubits::Int) = insert_qudits!(reg, loc, nqubits)
YaoAPI.insert_qudits!(loc::Int, nqudits::Int) =
    @λ(register -> insert_qudits!(register, loc, nqudits))
function YaoAPI.insert_qudits!(reg::AbstractArrayReg{D}, loc::Int, nqudits::Int) where D
    na = nactive(reg)
    focus!(reg, 1:loc-1)
    reg2 = join(zero_state_like(reg, nqudits), reg) |> relax! |> focus!((1:na+nqudits)...)
    reg.state = reg2.state
    reg
end

"""
    zero_state_like(register, n) -> AbstractRegister

Create a register initialized to zero from an existing one.

### Examples

```jldoctest; setup=:(using Yao)
julia> reg = rand_state(3; nbatch=2);

julia> zero_state_like(reg, 2)
BatchedArrayReg{2, ComplexF64, Array...}
    active qubits: 2/2
    nlevel: 2
    nbatch: 2
```
"""
function zero_state_like(reg::ArrayReg{D,T}, nqudits::Int) where {D,T}
    state = similar(reg.state, D^nqudits, _asint(nbatch(reg)))   # NOTE: does not preserve adjoint
    fill!(state,zero(T))
    state[1,1:1] .= Ref(one(T))  # broadcast to make it GPU compatible.
    return ArrayReg{D}(state)
end
function zero_state_like(reg::BatchedArrayReg{D,T}, nqudits::Int) where {D,T}
    state = similar(reg.state, D^nqudits, _asint(nbatch(reg)))   # NOTE: does not preserve adjoint
    fill!(state, zero(T))
    reshape(state, :, reg.nbatch)[1,:] .= Ref(one(T))  # broadcast to make it GPU compatible.
    return BatchedArrayReg{D}(state, reg.nbatch)
end

function YaoAPI.probs(r::ArrayReg)
    if size(r.state, 2) == 1
        return vec(r.state .|> abs2)
    else
        return dropdims(sum(r.state .|> abs2, dims = 2), dims = 2)
    end
end

function YaoAPI.probs(r::BatchedArrayReg)
    if size(r.state, 2) == nbatch(r)
        return r.state .|> abs2
    else
        probs = r |> rank3 .|> abs2
        return dropdims(sum(probs, dims = 2), dims = 2)
    end
end

YaoAPI.invorder!(r::AbstractRegister) = reorder!(r, Tuple(nactive(r):-1:1))
function YaoAPI.reorder!(r::AbstractArrayReg, orders)
    @assert nactive(r) == length(orders)
    st = reshape(r.state,fill(nlevel(r),nactive(r))...,size(r.state,2))
    r.state = reshape(permutedims(st, sortperm([collect(orders)..., length(orders)+1])), size(r.state))
    return r
end

function YaoAPI.collapseto!(r::AbstractArrayReg, bit_config::Integer)
    st = normalize!(r.state[Int(bit_config)+1, :])
    fill!(r.state, 0)
    r.state[Int(bit_config)+1, :] .= st
    return r
end

function YaoAPI.fidelity(r1::BatchedArrayReg{D}, r2::BatchedArrayReg{D}) where {D}
    B1, B2 = nbatch(r1), nbatch(r2)
    B1 == B2 || throw(DimensionMismatch("Register batch not match!"))
    B = nbatch(r1)

    state1 = rank3(r1)
    state2 = rank3(r2)
    size(state1) == size(state2) || throw(DimensionMismatch("Register size not match!"))
    if size(state1, 2) == 1
        res = map(b -> pure_state_fidelity(state1[:, 1, b], state2[:, 1, b]), 1:B)
    else
        res = map(b -> purification_fidelity(state1[:, :, b], state2[:, :, b]), 1:B)
    end
    return res
end

function YaoAPI.fidelity(r1::BatchedArrayReg, r2::ArrayReg)
    B = nbatch(r1)
    state1 = rank3(r1)
    state2 = rank3(r2)
    nqudits(r1) == nqudits(r2) || throw(DimensionMismatch("Register size not match!"))
    if size(state1, 2) == 1
        res = map(b -> pure_state_fidelity(state1[:, 1, b], state2[:, 1, 1]), 1:B)
    else
        res = map(b -> purification_fidelity(state1[:, :, b], state2[:, :, 1]), 1:B)
    end
    return res
end

YaoAPI.fidelity(r1::ArrayReg, r2::BatchedArrayReg) = YaoAPI.fidelity(r2, r1)

function YaoAPI.fidelity(r1::ArrayReg, r2::ArrayReg)
    state1 = state(r1)
    state2 = state(r2)
    nactive(r1) == nactive(r2) || throw(DimensionMismatch("Register size not match!"))

    if size(state1, 2) == 1 && size(state2, 2) == 1
        return pure_state_fidelity(state1[:, 1], state2[:, 1])
    else
        return purification_fidelity(state1, state2)
    end
end

YaoAPI.tracedist(r1::ArrayReg, r2::ArrayReg) = tracedist(density_matrix(r1), density_matrix(r2))
YaoAPI.tracedist(r1::BatchedArrayReg, r2::BatchedArrayReg) = tracedist.(r1, r2)


# properties
"""
    state(register::AbstractArrayReg) -> Matrix

Returns the raw array storage of `register`. See also [`statevec`](@ref).
"""
state(r::AbstractArrayReg) = r.state
chstate(::ArrayReg{D}, state) where D = ArrayReg{D}(state)
chstate(reg::BatchedArrayReg{D}, state) where D = BatchedArrayReg{D}(state, nbatch(reg))
state(r::AdjointArrayReg) = adjoint(state(parent(r)))

"""
    statevec(r::ArrayReg) -> array

Return a state matrix/vector by droping the last dimension of size 1 (i.e. `nactive(r) = nqudits(r)`).
See also [`state`](@ref).

!!! warning

    `statevec` is not type stable. It may cause performance slow down.
"""
statevec(r::ArrayRegOrAdjointArrayReg) = matvec(state(r))

"""
    relaxedvec(r::AbstractArrayReg) -> AbstractArray

Return a vector representation of state, with all qudits activated.
See also [`state`](@ref), [`statevec`](@ref).
"""
relaxedvec(r::ArrayReg) = vec(state(r))
relaxedvec(r::BatchedArrayReg) = reshape(state(r), :, nbatch(r))

"""
    hypercubic(r::ArrayReg) -> AbstractArray

Return the hypercubic representation (high dimensional tensor) of this register, only active qudits are considered.
See also [`rank3`](@ref) and [`state`](@ref).
"""
BitBasis.hypercubic(r::ArrayRegOrAdjointArrayReg) =
    reshape(state(r), ntuple(i -> nlevel(r), Val(nactive(r)))..., :)

"""
    rank3(r::ArrayReg)

Return the rank 3 tensor representation of state, the 3 dimensions are (activated space, remaining space, batch dimension).
See also [`hypercubic`](@ref) and [`state`](@ref).
"""
function rank3(r::ArrayRegOrAdjointArrayReg)
    s = state(r)
    reshape(s, size(s, 1), :, _asint(nbatch(r)))
end

"""
$(TYPEDSIGNATURES)

Concatenate a list of registers, each register should
have the same number of level and batch size. See also [`clone`](@ref).

```jldoctest; setup=:(using Yao)
julia> reg = join(product_state(bit"111"), zero_state(3))
ArrayReg{2, ComplexF64, Array...}
    active qubits: 6/6
    nlevel: 2

julia> measure(reg; nshots=3)
3-element Vector{DitStr{2, 6, Int64}}:
 111000 ₍₂₎
 111000 ₍₂₎
 111000 ₍₂₎
```
"""
function Base.join(r0::AbstractArrayReg{D}, rs::AbstractArrayReg{D}...)::AbstractArrayReg where D
    length(rs) == 0 && return r0
    state = batched_kron(rank3(r0), rank3.(rs)...)
    return arrayreg(reshape(state, size(state, 1), :), nbatch=nbatch(rs[1]), nlevel=D)
end

# initialization methods
"""
    product_state([T=ComplexF64], dit_str; nbatch=NoBatch(), no_transpose_storage=false)
    product_state([T=ComplexF64], nbits::Int, val::Int; nbatch=NoBatch(), nlevel=2, no_transpose_storage=false)
    product_state([T=ComplexF64], vector; nbatch=NoBatch(), nlevel=2, no_transpose_storage=false)

Create an [`ArrayReg`](@ref) of product state.
The configuration can be specified with a dit string, which can be defined with [`@bit_str`](@ref) or [`@dit_str`](@ref).
Or equivalently, it can be specified explicitly with `nbits`, `val` and `nlevel`.
See also [`zero_state`](@ref), [`rand_state`](@ref), [`uniform_state`](@ref).

### Examples

```jldoctest; setup=:(using Yao)
julia> reg = product_state(dit"120;3"; nbatch=2)
BatchedArrayReg{3, ComplexF64, Transpose...}
    active qudits: 3/3
    nlevel: 3
    nbatch: 2

julia> measure(reg)
1×2 Matrix{BitBasis.DitStr64{3, 3}}:
 120 ₍₃₎  120 ₍₃₎

julia> product_state(bit"100"; nbatch=2);

julia> r1 = product_state(ComplexF32, bit"001"; nbatch=2);

julia> r2 = product_state(ComplexF32, [1, 0, 0]; nbatch=2);

julia> r3 = product_state(ComplexF32, 3, 0b001; nbatch=2);

julia> r1 ≈ r2   # because we read bit strings from right to left, vectors from left to right.
true

julia> r1 ≈ r3
true
```
"""
function product_state(::Type{T}, bit_str::DitStr{D,N,Ti};
        nbatch::Union{Int,NoBatch} = NoBatch(),
        no_transpose_storage::Bool = false,
        ) where {D,T,N,Ti}
    if nbatch isa NoBatch || no_transpose_storage
        raw = zeros(T, D ^ N, _asint(nbatch))
    else
        # transposed storage
        raw = zeros(T, _asint(nbatch), D ^ N)
        raw = transpose(raw)
    end
    raw[buffer(bit_str)+1,:] .= Ref(one(T))
    return arrayreg(raw; nbatch=nbatch, nlevel=D)
end
# vector input
function product_state(::Type{T}, bit_configs::AbstractVector;
        nlevel::Int=2, kwargs...) where {T}
    return product_state(T, DitStr{nlevel}(bit_configs); kwargs...)
end
# integer input
function product_state(::Type{T}, total::Int, val::Integer;
        nlevel::Int=2,
        kwargs...) where {T}
    product_state(T, DitStr{nlevel,total}(val); kwargs...)
end

# default type
product_state(dit_str::DitStr; kwargs...) =
    product_state(ComplexF64, dit_str; kwargs...)
product_state(vector::AbstractVector; kwargs...) =
    product_state(ComplexF64, vector; kwargs...)
product_state(total::Int, val::Integer; kwargs...) =
    product_state(ComplexF64, total, val; kwargs...)

"""
    zero_state([T=ComplexF64], n::Int; nbatch::Int=NoBatch())

Create an [`AbstractArrayReg`](@ref) that initialized to state ``|0\\rangle^{\\otimes n}``.
See also [`product_state`](@ref), [`rand_state`](@ref), [`uniform_state`](@ref) and [`ghz_state`](@ref).

### Examples

```jldoctest; setup=:(using Yao)
julia> zero_state(4)
ArrayReg{2, ComplexF64, Array...}
    active qubits: 4/4
    nlevel: 2

julia> zero_state(ComplexF32, 4)
ArrayReg{2, ComplexF32, Array...}
    active qubits: 4/4
    nlevel: 2

julia> zero_state(ComplexF32, 4; nbatch=3)
BatchedArrayReg{2, ComplexF32, Transpose...}
    active qubits: 4/4
    nlevel: 2
    nbatch: 3
```
"""
zero_state(n::Int; kwargs...) = zero_state(ComplexF64, n; kwargs...)
zero_state(::Type{T}, n::Int; kwargs...) where {T} = product_state(T, n, 0; kwargs...)

"""
    ghz_state([T=ComplexF64], n::Int; nbatch::Int=NoBatch())

Create a GHZ state (or a cat state) that defined as

```math
\\frac{|0\\rangle^{\\otimes n} + |1\\rangle^{\\otimes n}}{\\sqrt{2}}.
```

### Examples

```jldoctest; setup=:(using Yao)
julia> ghz_state(4)
ArrayReg{2, ComplexF64, Array...}
    active qubits: 4/4
    nlevel: 2
```
"""
ghz_state(n::Int; kwargs...) = ghz_state(ComplexF64, n; kwargs...)
function ghz_state(::Type{T}, n::Int; kwargs...) where {T}
    reg = zero_state(T, n; kwargs...)
    reg.state[1,:] .= Ref(sqrt(inv(T(2))))  # make symbolic feel better
    reg.state[end,:] .= Ref(sqrt(inv(T(2))))
    return reg
end

"""
    rand_state([T=ComplexF64], n::Int; nbatch=NoBatch(), no_transpose_storage=false)

Create a random [`AbstractArrayReg`](@ref) with total number of qudits `n`.

### Examples

```jldoctest; setup=:(using Yao)
julia> rand_state(4)
ArrayReg{2, ComplexF64, Array...}
    active qubits: 4/4
    nlevel: 2

julia> rand_state(ComplexF64, 4)
ArrayReg{2, ComplexF64, Array...}
    active qubits: 4/4
    nlevel: 2

julia> rand_state(ComplexF64, 4; nbatch=2)
BatchedArrayReg{2, ComplexF64, Transpose...}
    active qubits: 4/4
    nlevel: 2
    nbatch: 2
```
"""
rand_state(n::Int; kwargs...) = rand_state(ComplexF64, n; kwargs...)

function rand_state(
    ::Type{T},
    n::Int;
    nbatch::Union{Int,NoBatch} = NoBatch(),
    no_transpose_storage::Bool = false,
    nlevel = 2,
) where {T}
    raw =
        nbatch isa NoBatch || no_transpose_storage ? randn(T, nlevel ^ n, _asint(nbatch)) :
        transpose(randn(T, _asint(nbatch), nlevel ^ n))
    return normalize!(arrayreg(raw; nbatch=nbatch, nlevel=nlevel))
end

"""
    uniform_state([T=ComplexF64], n; nbatch=NoBatch(), no_transpose_storage=false)

Create a uniform state:
```math
\\frac{1}{\\sqrt{2^n}} \\sum_{k=0}^{2^{n}-1} |k\\rangle.
```
This state can also be created by applying `H` (Hadmard gate) on ``|00⋯00⟩`` state.

### Example

```jldoctest; setup=:(using Yao)
julia> uniform_state(4; nbatch=2)
BatchedArrayReg{2, ComplexF64, Transpose...}
    active qubits: 4/4
    nlevel: 2
    nbatch: 2

julia> uniform_state(ComplexF32, 4; nbatch=2)
BatchedArrayReg{2, ComplexF32, Transpose...}
    active qubits: 4/4
    nlevel: 2
    nbatch: 2
```
"""
uniform_state(n::Int; kwargs...) = uniform_state(ComplexF64, n; kwargs...)

function uniform_state(::Type{T}, n::Int;
    nbatch::Union{Int,NoBatch} = NoBatch(),
    nlevel::Int = 2,
    no_transpose_storage::Bool = false,
) where {T}
    if (nbatch isa NoBatch) || no_transpose_storage
        raw = ones(T, nlevel ^ n, _asint(nbatch))
    else
        raw = transpose(ones(T, _asint(nbatch), nlevel ^ n))
    end
    return normalize!(arrayreg(raw; nbatch=nbatch, nlevel=nlevel))
end

"""
    oneto(n::Int) -> f(register)
    oneto(r::AbstractArrayReg, n::Int=nqudits(r))

Returns an register with `1:n` qudits activated, which is faster than the general purposed [`focus`](@ref) function.
"""
oneto(n::Int) = r -> oneto(r, n)
oneto(r::AbstractArrayReg{D}, n::Int = nqudits(r)) where {D} =
    arrayreg(reshape(copy(r.state), D ^ n, :), nbatch=nbatch(r), nlevel=D)
oneto(r::AbstractArrayReg{D,T,<:Transpose}, n::Int = nqudits(r)) where {D,T} =
    transpose_storage(arrayreg(reshape(r.state, D ^ n, :); nbatch=nbatch(r), nlevel=D))

YaoAPI.clone(r::AbstractArrayReg{D}, n::Int) where D =
    BatchedArrayReg{D}(hcat((state(r) for k = 1:n)...), n * _asint(nbatch(r)))

# NOTE: overload this to make printing more compact
#       but do not alter the way how type parameters print
qubit_type(::AbstractArrayReg{2}) = "qubits"
qubit_type(::AbstractArrayReg) = "qudits"

function Base.show(io::IO, reg::ArrayReg{D,T,MT}) where {D,T,MT}
    print(io, "ArrayReg{$D, $T, $(nameof(MT))...}")
    print(io, "\n    active $(qubit_type(reg)): ", nactive(reg), "/", nqudits(reg))
    print(io, "\n    nlevel: ", nlevel(reg))
end

function Base.show(io::IO, reg::BatchedArrayReg{D,T,MT}) where {D,T,MT}
    print(io, "BatchedArrayReg{$D, $T, $(nameof(MT))...}")
    print(io, "\n    active $(qubit_type(reg)): ", nactive(reg), "/", nqudits(reg))
    print(io, "\n    nlevel: ", nlevel(reg))
    print(io, "\n    nbatch: ", nbatch(reg))
end

"""
    print_table([io::IO, ]register; digits::Int=5)

Print configuration-amplitude pairs of the `register`.

```jldoctest; setup=:(using Yao)
julia> reg = ghz_state(2);

julia> print_table(ghz_state(2))
00 ₍₂₎   0.70711 - 0.0im
01 ₍₂₎   0.0 + 0.0im
10 ₍₂₎   0.0 + 0.0im
11 ₍₂₎   0.70711 - 0.0im
```
"""
print_table(reg::AbstractArrayReg; digits::Int=5) = print_table(stdout, reg; digits)
function print_table(io::IO, reg::AbstractArrayReg; digits::Int=5)
    data = rank3(reg)
    for i in basis(reg)
        print(io, "$i   ")
        for b in 1:size(data, 3)
            for r in 1:size(data, 2)
                s = round(data[buffer(i)+1,r,b]; digits)
                print(io, s)
                if r != size(data, 2)
                    print(io, ", ")
                end
            end
            b !== size(data, 3) && print(io, "; ")
        end
        println(io)
    end
end

"""
    mutual_information(register_or_rho, part1, part2)

Returns the mutual information between subsystems `part1` and `part2` of the input quantum register or density matrix:

```math
S(\\rho_A) + S(\\rho_B) - S(\\rho_{AB})
```

### Example

The mutual information of a GHZ state of any two disjoint parts is always equal to ``\\log 2``.

```jldoctest; setup=:(using Yao)
julia> mutual_information(ghz_state(4), (1,), (3,4))
0.6931471805599132
```
"""
function mutual_information(reg::AbstractArrayReg, part1, part2)
    @assert_locs_safe nqudits(reg) collect(Iterators.flatten((part1, part2)))
    von_neumann_entropy(reg, part1) .+ von_neumann_entropy(reg, part2) .- von_neumann_entropy(reg, part1 ∪ part2)
end

"""
    von_neumann_entropy(reg::AbstractArrayReg, part)
    von_neumann_entropy(ρ::DensityMatrix)

The entanglement entropy between `part` and the rest part in quantum state `reg`.
If the input is a density matrix, it returns the entropy of a mixed state.

### Example

The Von Neumann entropy of any segment of GHZ state is ``\\log 2``.

```jldoctest; setup=:(using Yao)
julia> von_neumann_entropy(ghz_state(3), (1,2))
0.6931471805599612
```
"""
von_neumann_entropy(reg::BatchedArrayReg, part) = von_neumann_entropy.(reg, Ref(part))
von_neumann_entropy(reg::ArrayReg, part) = von_neumann_entropy(density_matrix(reg, part))

function Base.iterate(it::Union{BatchedArrayReg{D}, AdjointRegister{D, <:BatchedArrayReg{D}}} where D, state = 1)
    if state > nbatch(it)
        return nothing
    else
        return viewbatch(it, state), state + 1
    end
end

Base.length(r::BatchedArrayReg) = r.nbatch
Base.length(r::AdjointRegister{D, <:BatchedArrayReg{D}}) where {D} = length(parent(r))

"""
    nbatch(register) -> Union{Int,NoBatch()}

Returns the number of batches.
"""
nbatch(r::BatchedArrayReg) = r.nbatch
nbatch(r::ArrayReg) = NoBatch()
nbatch(r::AdjointArrayReg) = nbatch(parent(r))

"""
$(TYPEDSIGNATURES)

Find `n` most probable qubit configurations in a quantum register and return these configurations as a vector of `DitStr` instances.

### Example

```jldoctest; setup=:(using Yao)
julia> most_probable(ghz_state(3), 2)
2-element Vector{DitStr{2, 3, Int64}}:
 000 ₍₂₎
 111 ₍₂₎
```
"""
function most_probable(reg::ArrayReg{D}, n::Int) where D
    imax = sortperm(probs(reg); rev=true)[1:n]
    return DitStr{D,nqudits(reg)}.(imax .- 1)
end

function most_probable(reg::BatchedArrayReg{D}, n::Int) where D
    res = Matrix{DitStr{D,nqudits(reg),Int}}(undef, n, reg.nbatch)
    for b = 1:nbatch(reg)
        res[:, b] .= most_probable(viewbatch(reg, b), n)
    end
    return res
end

"""
    basis(register) -> UnitRange

Returns an `UnitRange` of the all the bits in the Hilbert space of given register.

```jldoctest; setup=:(using Yao)
julia> collect(basis(rand_state(3)))
8-element Vector{DitStr{2, 3, Int64}}:
 000 ₍₂₎
 001 ₍₂₎
 010 ₍₂₎
 011 ₍₂₎
 100 ₍₂₎
 101 ₍₂₎
 110 ₍₂₎
 111 ₍₂₎
```
"""
BitBasis.basis(r::AbstractRegister{D}) where D = basis(DitStr{D,nactive(r),Int})


"""
    partial_tr(locs) -> f(ρ)

Curried version of `partial_tr(ρ, locs)`.
"""
YaoAPI.partial_tr(locs) = @λ(ρ -> partial_tr(ρ, locs))

Base.getindex(reg::ArrayReg{D}, d::DitStr{D}) where D = getindex(reg.state, buffer(d)+1)
Base.getindex(reg::BatchedArrayReg{D}, d::DitStr{D}) where D = getindex(reg.state, buffer(d)+1, :)

## from original YaoAPI
YaoAPI.measure!(postprocess::PostProcess, op, reg::AbstractRegister; kwargs...) =
    measure!(postprocess, op, reg, AllLocs(); kwargs...)
YaoAPI.measure!(postprocess::PostProcess, reg::AbstractRegister, locs; kwargs...) =
    measure!(postprocess, ComputationalBasis(), reg, locs; kwargs...)
YaoAPI.measure!(postprocess::PostProcess, reg::AbstractRegister; kwargs...) =
    measure!(postprocess, ComputationalBasis(), reg, AllLocs(); kwargs...)
YaoAPI.measure!(op, reg::AbstractRegister, args...; kwargs...) =
    measure!(NoPostProcess(), op, reg, args...; kwargs...)
YaoAPI.measure!(reg::AbstractRegister, args...; kwargs...) =
    measure!(NoPostProcess(), reg, args...; kwargs...)

YaoAPI.measure(op, reg::AbstractRegister; kwargs...) = measure(op, reg, AllLocs(); kwargs...)
YaoAPI.measure(reg::AbstractRegister, locs; kwargs...) =
    measure(ComputationalBasis(), reg, locs; kwargs...)
YaoAPI.measure(reg::AbstractRegister; kwargs...) =
    measure(ComputationalBasis(), reg, AllLocs(); kwargs...)

# focus! to specify locations, we that we only need to consider full-space measure in the future.
function YaoAPI.measure!(
    postprocess::PostProcess,
    op,
    reg::AbstractRegister,
    locs;
    kwargs...,
)
    nbit = nactive(reg)
    focus!(reg, locs)
    res = measure!(postprocess, op, reg, AllLocs(); kwargs...)
    if postprocess isa RemoveMeasured
        relax!(reg; to_nactive = nbit - length(locs))
    else
        relax!(reg, locs; to_nactive = nbit)
    end
    res
end

function YaoAPI.measure(op, reg::AbstractRegister, locs; kwargs...)
    nbit = nactive(reg)
    focus!(reg, locs)
    res = measure(op, reg, AllLocs(); kwargs...)
    relax!(reg, locs; to_nactive = nbit)
    res
end

function _measure(rng::AbstractRNG, base, pl::AbstractVector, nshots::Int)
    sample(rng, base, Weights(pl), nshots)
end

function _measure(rng::AbstractRNG, base, pl::AbstractMatrix, nshots::Int)
    B = size(pl, 2)
    res = Matrix{eltype(base)}(undef, nshots, B)
    for ib = 1:B
        @inbounds res[:, ib] = _measure(rng, base, view(pl, :, ib), nshots)
    end
    return res
end

YaoAPI.measure(
    ::ComputationalBasis,
    reg::ArrayReg,
    ::AllLocs;
    nshots::Int = 1,
    rng::AbstractRNG = Random.GLOBAL_RNG,
) = _measure(rng, basis(reg), reg |> probs, nshots)

function YaoAPI.measure(
    ::ComputationalBasis,
    reg::BatchedArrayReg,
    ::AllLocs;
    nshots::Int = 1,
    rng::AbstractRNG = Random.GLOBAL_RNG,
)
    pl = dropdims(sum(reg |> rank3 .|> abs2, dims = 2), dims = 2)
    return _measure(rng, basis(reg), pl, nshots)
end

function YaoAPI.measure!(
    ::YaoAPI.RemoveMeasured,
    ::ComputationalBasis,
    reg::AbstractArrayReg{D},
    ::AllLocs;
    rng::AbstractRNG = Random.GLOBAL_RNG,
) where {D}
    state = reg |> rank3
    B = size(state, 3)
    nstate = similar(reg.state, D ^ nremain(reg), B)
    pl = dropdims(sum(state .|> abs2, dims = 2), dims = 2)
    res = Vector{eltype(basis(reg))}(undef, B)
    @inbounds for ib = 1:B
        ires = _measure(rng, basis(reg), view(pl, :, ib), 1)[]
        # notice ires is `BitStr` type, can be use as indices directly.
        nstate[:, ib] = view(state, Int64(ires) + 1, :, ib) ./ sqrt(pl[Int64(ires)+1, ib])
        res[ib] = ires
    end
    reg.state = reshape(nstate, 1, :)
    return reg isa ArrayReg ? res[] : res
end

function YaoAPI.measure!(
    ::YaoAPI.NoPostProcess,
    ::ComputationalBasis,
    reg::AbstractArrayReg,
    ::AllLocs;
    rng::AbstractRNG = Random.GLOBAL_RNG,
)
    state = reg |> rank3
    M, N, B = size(state)
    nstate = zero(state)
    res = measure!(RemoveMeasured(), reg; rng = rng)
    _nstate = reshape(reg.state, :, B)
    indices = Int64.(res) .+ 1
    for ib = 1:B
        @inbounds nstate[indices[ib], :, ib] .= view(_nstate, :, ib)
    end
    reg.state = reshape(nstate, M, :)
    return res
end

function YaoAPI.measure!(
    rst::YaoAPI.ResetTo,
    ::ComputationalBasis,
    reg::AbstractArrayReg,
    ::AllLocs;
    rng::AbstractRNG = Random.GLOBAL_RNG,
)
    state = rank3(reg)
    M, N, B = size(state)
    nstate = zero(state)
    res = measure!(YaoAPI.RemoveMeasured(), reg; rng = rng)
    nstate[Int(rst.x)+1, :, :] = reshape(reg.state, :, B)
    reg.state = reshape(nstate, M, N * B)
    return res
end

## DensityMatrix
YaoAPI.measure(
    ::ComputationalBasis,
    rho::DensityMatrix,
    ::AllLocs;
    nshots::Int = 1,
    rng::AbstractRNG = Random.GLOBAL_RNG,
) = _measure(rng, basis(rho), rho |> probs, nshots)


function YaoAPI.measure(op, rho::DensityMatrix, locs; kwargs...)
    rrho = density_matrix(rho, locs)
    res = measure(op, rrho, AllLocs(); kwargs...)
    return res
end

function YaoAPI.measure!(
    postprocess::PostProcess,
    op::ComputationalBasis,
    rho::DensityMatrix,
    locs;
    rng::AbstractRNG = Random.GLOBAL_RNG,
)
    if !(locs isa AllLocs)
        rrho = density_matrix(rho, locs)
        bs = basis(rrho)
        ps = rrho |> probs
    else
        bs = basis(rho)
        ps = rho |> probs
    end
    res = _measure(rng, bs, ps, 1)[]
    if postprocess isa RemoveMeasured
        ic = itercontrol(nqudits(rho), collect(locs isa AllLocs ? (1:nqudits(rho)) : locs), res) .+ 1
        rho.state = rho.state[ic, ic]
        normalize!(rho)
    elseif postprocess isa NoPostProcess
        collapseto!(rho, locs => res)
    elseif postprocess isa ResetTo
        collapseto!(rho, locs => postprocess.x)
    else
        error("`$postprocess` is not yet supported for DensityMatrix")
    end
    return res
end

import YaoAPI: select, select!
select(r::AbstractArrayReg, bits::AbstractVector{T}) where {T<:Integer} =
    arrayreg(r.state[Int64.(bits).+1, :]; nbatch=nbatch(r), nlevel=nlevel(r))
select(r::AbstractArrayReg, bit::Integer) = select(r, [bit])
select!(bits...) = @λ(register -> select!(register, bits...))

function select!(r::AbstractArrayReg, bits::AbstractVector{T}) where {T<:Integer}
    r.state = r.state[Int64.(bits).+1, :]
    return r
end

select!(r::AbstractArrayReg, bit::Integer) = select!(r, [bit])

using SparseArrays
function YaoAPI.instruct!(::Val{D},
    state::AbstractVecOrMat{T},
    operator::AbstractMatrix{T},
    locs::NTuple{M,Int},
    control_locs::NTuple{C,Int},
    control_bits::NTuple{C,Int}
) where {T,M,C,D}
    if length(control_locs) !== 0 || length(control_bits) !== 0
        error("controlled qudit gates are not supported!")
    end
    # TODO: add single qudit optimization
    return instruct!(Val(D), state, operator, locs)
end

function YaoAPI.instruct!(::Val{D},
    state::AbstractVecOrMat{T},
    operator::AbstractMatrix{T},
    locs::NTuple{M,Int},
) where {T,M,D}
    # prepare instruct
    operator = sort_unitary(Val{D}(), operator, locs)
    ndits = logdi(size(state, 1), D)
    qudit_instruct!(Val{D}(), ndits, state, autostatic(operator), TupleTools.sort(locs))
end

function qudit_instruct!(::Val{D}, nbits::Int, state::AbstractVecOrMat{T}, operator::AbstractMatrix{T}, locs::NTuple{M,Int}) where {T,M,D}
    strides = ntuple(i->D^(i-1), nbits)
    baselocs = (setdiff(1:nbits, locs)...,)
    basestrides = map(i->strides[i], baselocs)
    substrides = map(i->strides[i], locs)

    subindices = SVector(ntuple(i->map_index(Val(D), i-1, substrides), D^M))
    #baseindices = [map_index(Val(D), i, basestrides) for i=0:D^(nbits-M)-1]

    _instruct!(Val(D), state, autostatic(operator), subindices, basestrides)
    return state
end

# specialize: IMatrix
function qudit_instruct!(::Val{D}, nbits::Int, state::AbstractVecOrMat{T}, operator::IMatrix, locs::NTuple{M,Int}) where {T,M,D}
    return state
end

@generated function _instruct!(::Val{D}, state::AbstractVecOrMat, U::AbstractMatrix, subindices::SVector, basestrides::NTuple{BN}) where {D,BN}
    quote
        sumc = length(basestrides) == 0 ? 1 : 1 - sum(basestrides)
        Base.Cartesian.@nloops($BN, i, d->1:$D,
                d->(@inbounds sumc += i_d*basestrides[d]), # PRE
                d->(@inbounds sumc -= i_d*basestrides[d]), # POST
                begin # BODY
                    @inbounds unrows!(state, subindices .+ sumc, U)
                end)

    end
end
@inline function map_index(::Val{D}, x, strides::NTuple{M,Int}) where {D,M}
    res = zero(x)
    for i=1:M
        x, rem = divrem(x, D)
        res += rem * strides[i]
    end
    return res
end

# specialize: Diagonal
function qudit_instruct!(::Val{D},
    nbits::Int,
    state::AbstractVecOrMat{T},
    operator::SDDiagonal{T},
    locs::NTuple{M,Int},
) where {T,M,D}
    # create stride for indexing
    strides = ntuple(i->D^(i-1), nbits)
    baselocs = (setdiff(1:nbits, locs)...,)
    basestrides = map(i->strides[i], baselocs)
    substrides = map(i->strides[i], locs)

    # allocate storage
    CI = CartesianIndices(ntuple(i->D, M))
    @threads for i=1:size(operator, 1)  # very limited multi-threading power
        # set indices
        @inbounds I = CI[i].I
        @inbounds ioffset = sum(i->(I[i]-1) * substrides[i], 1:M)
        instrloop_diag!(Val(D), state, operator.diag[i], ioffset, basestrides)
    end
    return state
end

@generated function instrloop_diag!(::Val{D}, state::AbstractVecOrMat, v, ioffset::Int, basestrides::NTuple{BN}) where {D,BN}
    quote
        sumc = 1 - sum(basestrides)
        Base.Cartesian.@nloops($BN, i, d->1:$D,
                d->(@inbounds sumc += i_d*basestrides[d]), # PRE
                d->(@inbounds sumc -= i_d*basestrides[d]), # POST
                begin # BODY
                    @inbounds mulrow!(state, ioffset + sumc, v)
                end)

    end
end

# TODO: add single qudit gate instruction.
# TODO: speed up sparse matrix and pm matrix gate.

using Test
using YaoArrayRegister, Random, LinearAlgebra, SparseArrays, BitBasis


@testset "broadcast register" begin
    reg = rand_state(5; nbatch = 3)
    @test typeof.(reg)[1] <: ArrayReg{2,ComplexF64,<:SubArray}
    @test [reg...] |> length == 3
    @test [rand_state(3; nbatch=2)...] |> length == 2
end

@testset "arithmetics" begin
    nbit = 5
    reg1 = zero_state(5)
    reg2 = arrayreg(bit"00100")
    @test reg1 != reg2
    @test statevec(reg2) == onehot(ComplexF64, BitStr64{nbit}(4))
    reg3 = reg1 + reg2
    reg4 = (reg1 + reg2)'

    @test statevec(reg3) == onehot(ComplexF64, BitStr64{nbit}(4)) + onehot(ComplexF64, BitStr64{nbit}(0))
    @test statevec(reg3 |> normalize!) ==
          (onehot(ComplexF64, BitStr64{nbit}(4)) + onehot(ComplexF64, BitStr64{nbit}(0))) / sqrt(2)
    @test statevec(reg4 |> normalize!) ==
          (onehot(ComplexF64, BitStr64{nbit}(4)) + onehot(ComplexF64, BitStr64{nbit}(0)))' / sqrt(2)
    @test (reg1 + reg2 - reg1) == reg2
    @test reg1' + reg2' - reg1' == reg2'
    @test isnormalized(reg4)
    @test isnormalized(reg3)

    @test statevec(-reg4) == -statevec(reg4)
    @test statevec(-reg3) == -statevec(reg3)
    reg = rand_state(4)
    @test all(state(reg + (-reg)) .== 0)
    @test all(state(reg * 2 - reg / 0.5) .== 0)

    reg = rand_state(3)
    @test norm(reg) ≈ 1
    @test reg' * reg ≈ 1

    @test state(reg1 * 2) == state(reg1) * 2
    @test state(reg1' * 2) == state(reg1') * 2
    @test reg1 * 2 == 2 * reg1
    @test reg1' * 2 == 2 * reg1'
    reg = rand_state(3; nbatch = 2) * 2
    @test norm(reg) ≈ [2.0, 2.0]
end

@testset "partial ⟨bra|ket⟩" begin
    bra = arrayreg(bit"10")
    ket = arrayreg(bit"100") + 2 * arrayreg(bit"110") + 3 * arrayreg(bit"111")

    focus!(ket, 2:3)
    @test_throws ErrorException bra' * ket

    relax!(ket, 2:3)
    focus!(ket, 1)
    focus!(bra, 2)
    @test_throws ErrorException bra' * ket

    reg1 = rand_state(5; nbatch = 10)
    reg2 = rand_state(5; nbatch = 10)
    @test reg1' * reg2 ≈ reg1' .* reg2
    reg1 = rand_state(2; nbatch = 10)
    reg2 = rand_state(5; nbatch = 10)
    focus!(reg2, 2:3)
    @test_throws ErrorException reg1' * reg2
end

@testset "inplace funcs" begin
    for reg in [
            rand_state(5; nbatch = NoBatch()),
            rand_state(5; nbatch = 3),
            transpose_storage(rand_state(5; nbatch = 3)),
        ]
        reg0 = copy(reg)
        @test regscale!(reg, 0.3) ≈ 0.3 * reg0
        reg1 = rand_state(5; nbatch = nbatch(reg))
        reg2 = rand_state(5; nbatch = nbatch(reg))
        reg10 = copy(reg1)
        regsub!(reg1, reg2)
        @test reg1 ≈ reg10 - reg2

        reg1 = rand_state(5; nbatch = nbatch(reg))
        reg2 = rand_state(5; nbatch = nbatch(reg))
        reg10 = copy(reg1)
        regadd!(reg1, reg2)
        @test reg1 ≈ reg10 + reg2
    end
end


@testset "more (push test coverage)" begin
    reg1 = focus!(rand_state(5; nbatch=5), (2, 3))
    reg2 = focus!(rand_state(5; nbatch=5), (2, 3))
    @test fidelity(reg1, reg2) ≈ fidelity(reg2, reg1)
    @test join(reg1) == reg1
    us = uniform_state(3; nlevel=3, nbatch=2)
    @test nbatch(us) == 2
    @test nlevel(us) == 3
    println(reg1)
    println(reg2)
    @test von_neumann_entropy(clone(reg2, 3), [2,1]) ≈ repeat(von_neumann_entropy(reg2, [1,2]), 3)
end

@testset "separable and safe remove" begin
    reg1, reg2 = rand_state(4), rand_state(2)
    reg = join(reg1, reg2)
    @test isseparable(reg, 1:2)
    @test isseparable(reg, 3:6)
    @test !isseparable(reg, 1:3)
    @test fidelity(safe_remove!(copy(reg), 1:2), reg1) ≈ 1
    @test fidelity(safe_remove!(copy(reg), 3:6), reg2) ≈ 1
    @test_throws ErrorException safe_remove!(copy(reg), 1:3)

    reg1, reg2 = rand_state(4; nlevel=3, nbatch=3), rand_state(2; nlevel=3, nbatch=3)
    reg = join(reg1, reg2)
    @test isseparable(reg, 1:2)
    @test isseparable(reg, 3:6)
    @test !isseparable(reg, 1:3)
    @test fidelity(safe_remove!(copy(reg), 1:2), reg1) ≈ ones(3)
    @test fidelity(safe_remove!(copy(reg), 3:6), reg2) ≈ ones(3)
    @test_throws ErrorException safe_remove!(copy(reg), 1:3)
end
